package org.processmining.dataquality;

import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;

public class DetectionAndRepairModel {

	static int k = 4; //window size - for number of events in batch processing

	static DetectionModel detectionModel;



	static RepairModel repairModel;

	static InteractivePetriNet ipn;

	public DetectionAndRepairModel(InteractivePetriNet ipn) {
		this.ipn = ipn;

	
		detectionModel = new DetectionModel(ipn.getEventNames());
		detectionModel.detect(ipn.getLog(), k);

		repairModel = new RepairModel(ipn);
	}

	public static DetectionModel getDetectionModel() {
		return detectionModel;
	}

	public static void setDetectionModel(DetectionModel detectionModel) {
		DetectionAndRepairModel.detectionModel = detectionModel;
	}

//	public static JPanel getRepairPanel() {
//		return repairModel.getRepairPanel();
//	}

	public void updateRepairActivities() {
		repairModel.updateActivities();

	}

	public static RepairModel getRepairModel() {
		return repairModel;
	}

}
