package org.processmining.dataquality.Reasons;

public class ReasonMapping {

	public enum Reasons {
		StatsRelatedDayOfMonth,StatsRelatedMin, StatsRelatedHour, StatsRelatedDayOfWeek, StatsRelatedMonth, DirectlyRelationsIssues, EventualRelationsIssues, MixedGranularityOfDifferentEvents, MixedGranularityOfSameEvent, CoarseGrainedTimeStamps, SameTimeStampValues, NoTimeStampValue, MixedGranularityOfDifferentEventsSequence
	}

	public static String getReason(Reasons reason) {
		if (reason == null)
			return "";
		switch (reason) {
			case CoarseGrainedTimeStamps :
				return "These activities have coarse grained timestamps";
			case MixedGranularityOfDifferentEvents :
				return "These set of closely related events have different granularity of timestamps.";
			case MixedGranularityOfDifferentEventsSequence :
				return "These set of closely related events have different granularity of timestamps.";
			case MixedGranularityOfSameEvent :
				return "The occurrence of this activity has different granularity of timestamps across the event log.";
			case NoTimeStampValue :
				return "These activities have no timestamp values associated with it.";
			case SameTimeStampValues :
				return "These group of activities share the same timestamp values.";
			case DirectlyRelationsIssues :
				return "Issues in directly follows/precedes relations";
			case EventualRelationsIssues :
				return "Issues in eventual follows/precedes relations";
			case StatsRelatedMonth :
				return "Problem with stats month distribution";
			case StatsRelatedDayOfMonth:
				return "Problem with day of month distribution";
			case StatsRelatedDayOfWeek:
				return "Problem with day of week distribution";
			case StatsRelatedHour:
				return "Problem with hours distribution";
			case StatsRelatedMin:
				return "Problem with mins distribution";
			default :
				break;
		}

		return "";

	}

}
