package org.processmining.dataquality.Reasons;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import org.deckfour.xes.model.XAttributeLiteral;
import org.deckfour.xes.model.XLog;
import org.processmining.dataquality.RepairModel;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.log.ReSortLog;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;
import org.processmining.prabhakardixit.alignments.ProjectedAveragedAlignments;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class RepairStatsPanel extends JPanel {

	JTabbedPane tab;
	int i = 1;
	List<XLog> logs;
	JButton useThisLog;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public RepairStatsPanel(final InteractivePetriNet ipn) {

		tab = new JTabbedPane();
		tab.add("Initial net", new JPanel());
		add(tab);
		i++;
		logs = new ArrayList<XLog>();
		logs.add(ipn.getLog());
		useThisLog = SlickerFactory.instance().createButton("Use This Log");
		useThisLog.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				int index = tab.getSelectedIndex();
				//TODO set the log of this index as ipn log
				ipn.setLog(logs.get(index));

			}
		});
	}

	public void addNewTab(XLog changedLog) {
		PNetVisualizerController controller = PNetVisualizerController.getInstance();
		RepairModel rm = controller.getIPN().getDqModel().getRepairModel();
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		int editDist = CalculationUtils.getEditDistance(
				ReSortLog.removeEdgePoints(controller.getIPN().getContext(), controller.getIPN().getLog()), changedLog);
		Set<String> acts = new HashSet<String>();
		for (Transition t : controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions()) {
			acts.add(t.getLabel());
		}

		XLog templog = ProjectedAveragedAlignments.createMergedLog(controller.getIPN().getLog(), acts, false);
		PNRepResult resultOrg = CalculateAlignments.calculateAlignments(templog);

		templog = ProjectedAveragedAlignments.createMergedLog(changedLog, acts, false);
		PNRepResult resultNew = CalculateAlignments.calculateAlignments(templog);
		System.out.println(("The edit distance is : " + editDist));
		panel.add(new JLabel("The activity added is : " + controller.getIPN().getDqModel().getRepairModel().getActToRepair().getSelectedItem().toString()));
		panel.add(new JLabel("The edit distance is : " + editDist));
		panel.add(new JLabel("The original fitness was:" + resultOrg.getInfo().get(PNRepResult.TRACEFITNESS)));
		panel.add(new JLabel("The new fitness is:" + resultNew.getInfo().get(PNRepResult.TRACEFITNESS)));
		panel.add(new JLabel("Number of traces changed is:"
				+ ((XAttributeLiteral) changedLog.getAttributes().get("casesChanged")).getValue()));
		panel.add(new JLabel("Number of events added are:"
				+ ((XAttributeLiteral) changedLog.getAttributes().get("eventsAdded")).getValue()));
		panel.add(new JLabel("Number of events removed are:"
				+ ((XAttributeLiteral) changedLog.getAttributes().get("eventsRemoved")).getValue()));
		panel.add(new JLabel("Number of events with time changed are:"
				+ ((XAttributeLiteral) changedLog.getAttributes().get("eventsChanged")).getValue()));
		//		add(new JButton("button"));
		tab.add(String.valueOf(i), panel);
		add(tab);
		tab.setSelectedIndex(i-1);
		panel.add(useThisLog);
		i++;
		logs.add(changedLog);
	}

	public RepairStatsPanel(XLog changedLog, boolean t22) {
		PNetVisualizerController controller = PNetVisualizerController.getInstance();
		RepairModel rm = controller.getIPN().getDqModel().getRepairModel();
		int editDist = CalculationUtils.getEditDistance(
				ReSortLog.removeEdgePoints(controller.getIPN().getContext(), controller.getIPN().getLog()), changedLog);
		Set<String> acts = new HashSet<String>();
		for (Transition t : controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions()) {
			acts.add(t.getLabel());
		}

		XLog templog = ProjectedAveragedAlignments.createMergedLog(controller.getIPN().getLog(), acts, false);
		PNRepResult resultOrg = CalculateAlignments.calculateAlignments(templog);

		templog = ProjectedAveragedAlignments.createMergedLog(changedLog, acts, false);
		PNRepResult resultNew = CalculateAlignments.calculateAlignments(changedLog);
		System.out.println(("The edit distance is : " + editDist));
		this.add(new JLabel("The edit distance is : " + editDist));
		add(new JButton("button"));
	}

}
