package org.processmining.dataquality;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.processmining.dataquality.Reasons.RepairDuration;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class RepairBox {
	//contains the panel 
	int id;

	JComboBox acts1;
	JComboBox acts2;
	JComboBox absRelative;
	JTextField unit;
	JPanel panel;
	

	public RepairBox(InteractivePetriNet ipn) {
		panel = new JPanel();
		panel.setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = 0;
		panel.add(new JLabel("After"), gbc);
		gbc.gridx = 1;
		panel.add(new JLabel("Approach"), gbc);
		gbc.gridx = 2;
		panel.add(new JLabel("Before"), gbc);
		gbc.gridx = 3;
		panel.add(new JLabel("Value"), gbc);

		addRow(ipn, 1);
	}

	public void addRow(InteractivePetriNet ipn, int numCols) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridy = numCols;
		List<String> actsInNet = new ArrayList<String>();
		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions())
			if (!t.isInvisible())
				actsInNet.add(t.getLabel());
		id = this.hashCode();
		String[] a1 = new String[actsInNet.size() + 2];
		a1[0] = "None";
		a1[1] = "Case start";
		String[] a2 = new String[actsInNet.size() + 2];
		a2[0] = "None";
		a2[1] = "Case end";

		for (int i = 0; i < actsInNet.size(); i++) {
			a1[i + 2] = actsInNet.get(i);
			a2[i + 2] = actsInNet.get(i);
		}
		acts1 = SlickerFactory.instance().createComboBox(a1);
		gbc.gridx = 0;
		panel.add(acts1, gbc);

		absRelative = SlickerFactory.instance().createComboBox(RepairDuration.values());
		gbc.gridx = 1;
		panel.add(absRelative, gbc);

		acts2 = SlickerFactory.instance().createComboBox(a2);
		gbc.gridx = 2;
		panel.add(acts2, gbc);

		unit = new JTextField("", 2);

		gbc.gridx = 3;
		panel.add(unit, gbc);
		gbc.gridx = 4;
		JButton delete = SlickerFactory.instance().createButton("X");
		panel.add(delete, gbc);
		delete.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				PNetVisualizerController.getInstance().getIPN().getDqModel().getRepairModel().removeRow(id);

			}
		});
	}

	public JPanel getPanel() {
		return panel;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
	public RepairDuration getRepairMethod(){
		return (RepairDuration) absRelative.getSelectedItem();
	}

	public JComboBox getActs1() {
		return acts1;
	}

	public void setActs1(JComboBox acts1) {
		this.acts1 = acts1;
	}

	public JComboBox getActs2() {
		return acts2;
	}

	public void setActs2(JComboBox acts2) {
		this.acts2 = acts2;
	}

	public JTextField getUnit() {
		return unit;
	}

	public void setUnit(JTextField unit) {
		this.unit = unit;
	}


}
