package org.processmining.dataquality;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.processmining.dataquality.Reasons.CalculateAlignments;
import org.processmining.dataquality.Reasons.RepairStatsPanel;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;

import com.fluxicon.slickerbox.factory.SlickerFactory;

public class RepairModel {

	static//list containing added details
	List<RepairBox> repairs;

	static JCheckBox add;
	static JCheckBox remove;
	static JCheckBox duplicates;
	static JComboBox actToRepair;

	static JButton addRow;
	static JPanel completeRepairPanel;

	static JPanel repairBoxPanel;
	//	static PNetVisualizerController controller;
	static InteractivePetriNet ipn;

	static JComboBox actCombo;

	static Map<String, Integer> weights;

	static RepairStatsPanel repairStatsPanel;

	public static void addRepairBox(InteractivePetriNet ipn) {
		RepairBox p = new RepairBox(ipn);
	}

	public JPanel createRepairPanel() {
		final PNetVisualizerController controller = PNetVisualizerController.getInstance();
		completeRepairPanel = new JPanel();
		add = SlickerFactory.instance().createCheckBox("Add", false);
		completeRepairPanel.add(add);
		remove = SlickerFactory.instance().createCheckBox("Remove", false);
		completeRepairPanel.add(remove);
		duplicates = SlickerFactory.instance().createCheckBox("Rename Duplicates in log", false);
		completeRepairPanel.add(duplicates);
		addRow = SlickerFactory.instance().createButton("Add New Row");
		addRow.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				RepairBox rb = new RepairBox(ipn);
				repairs.add(rb);
				repairBoxPanel.add(rb.getPanel());
				repairBoxPanel.repaint();
				repairBoxPanel.revalidate();

			}
		});

		completeRepairPanel.add(addRow);
		List<String> actsInNet = new ArrayList<String>();
		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions())
			if (!t.isInvisible())
				actsInNet.add(t.getLabel());
		String[] allActs = new String[ipn.getLogInfo().getActivities().size()];
		int i = 0;
		for (String s : ipn.getLogInfo().getActivities())
			allActs[i++] = s;

		String[] a1 = new String[actsInNet.size() + 1];
		a1[0] = "none";

		for (i = 0; i < actsInNet.size(); i++) {
			a1[i + 1] = actsInNet.get(i);
		}
		JPanel panel = new JPanel();
		panel.add(new JLabel("Activity to add to the net:"));
		actCombo = SlickerFactory.instance().createComboBox(allActs);
		panel.add(actCombo);
		actCombo.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				controller.getActivityCombo().setSelectedItem(actCombo.getSelectedItem().toString());
				controller.setActivity(controller.getActivityCombo().getSelectedItem().toString());

			}
		});
		panel.add(new JLabel("Activity to Repair:"));
		panel.setBorder(BorderFactory.createLineBorder(Color.black));
		actToRepair = SlickerFactory.instance().createComboBox(a1);
		actToRepair.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				for (String key : weights.keySet()) {
					if (key.equals(actToRepair.getSelectedItem().toString()))
						weights.put(key, 1);
					else
						weights.put(key, 2);
				}

			}
		});
		panel.add(actToRepair);
		completeRepairPanel.add(panel);
		repairBoxPanel = new JPanel();
		repairBoxPanel.setLayout(new BoxLayout(repairBoxPanel, BoxLayout.Y_AXIS));
		repairBoxPanel.removeAll();
		for (RepairBox repair : repairs) {
			repairBoxPanel.add(repair.getPanel());
		}

		JPanel panel2 = new JPanel();
		panel2.add(addSettingsDialogue());
		panel2.setBorder(BorderFactory.createLineBorder(Color.black));
		JButton alignments = SlickerFactory.instance().createButton("Calculate Alignments!");
		alignments.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				//TODO calculate alignments
				CalculateAlignments.calculateAlignments();
			}
		});
		panel2.add(alignments);
		completeRepairPanel.add(panel2);
		completeRepairPanel.add(repairBoxPanel);
		repairBoxPanel.repaint();
		repairBoxPanel.revalidate();
		return completeRepairPanel;
	}

	public RepairModel(final InteractivePetriNet ipn) {
		repairs = new ArrayList<RepairBox>();
		RepairBox p = new RepairBox(ipn);
		this.ipn = ipn;
		repairStatsPanel = new RepairStatsPanel(ipn);
		repairs.add(p);
		weights = new HashMap<String, Integer>();
		createRepairPanel();
	}

	public static JComboBox getActCombo() {
		return actCombo;
	}

	public static void setActCombo(JComboBox actCombo) {
		RepairModel.actCombo = actCombo;
	}

	//	public JPanel getRepairPanel() {
	//		return completeRepairPanel;
	//	}

	public static void updateActivities() {

		//if duplication is enabled, then update the controller dropdown with incremented act
		PNetVisualizerController controller = PNetVisualizerController.getInstance();
		String[] currAct = controller.getActivity().split("\\)");
		int len = 2;
		if (currAct.length > 1)
			len = Integer.valueOf(currAct[1]) + 1;
		if (duplicates.isSelected()) {

			String[] acts = new String[controller.getActivityCombo().getModel().getSize()];
			for (int i = 0; i < controller.getActivityCombo().getModel().getSize(); i++)
				if (controller.getActivity().equals(controller.getActivityCombo().getItemAt(i))) {
					acts[i] = currAct[0] + ")" + len;
				} else
					acts[i] = controller.getActivityCombo().getItemAt(i);

			DefaultComboBoxModel model = new DefaultComboBoxModel(acts);
			controller.getActivityCombo().setModel(model);
			actCombo.setModel(model);
		}
		List<String> actsInNet = new ArrayList<String>();
		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions())
			if (!t.isInvisible())
				actsInNet.add(t.getLabel());
		String[] a1 = new String[actsInNet.size() + 2];
		a1[0] = "None";
		a1[1] = "Case start";
		for (int i = 0; i < actsInNet.size(); i++)
			a1[i + 1] = actsInNet.get(i);

		Set<String> alreadyAddedToActRepair = new HashSet<String>();

		for (RepairBox rb : repairs) {

			//			rb.acts1 = SlickerFactory.instance().createComboBox(a1);
			Set<String> acts = new HashSet<String>();
			for (int i = 0; i < rb.acts1.getItemCount(); i++)
				acts.add(rb.acts1.getItemAt(i).toString());

			for (String s : actsInNet)
				if (!acts.contains(s)) {
					rb.acts1.addItem(s);
					rb.acts2.addItem(s);
					if (alreadyAddedToActRepair.add(s)) {
						actToRepair.addItem(s);
						weights.put(s, 1);
					}
				}

		}

		controller.getInfoPanel().repaint();
		controller.getInfoPanel().revalidate();
		//		completeRepairPanel.add((new RepairBox(ipn)).getPanel());

	}

	public static void removeRow(int id) {
		RepairBox boxToRemove = null;
		repairBoxPanel.removeAll();
		for (RepairBox repair : repairs) {
			if (repair.getId() != id)
				repairBoxPanel.add(repair.getPanel());
			else
				boxToRemove = repair;

		}
		if (boxToRemove != null)
			repairs.remove(boxToRemove);
		repairBoxPanel.repaint();
		repairBoxPanel.revalidate();
	}

	private JButton addSettingsDialogue() {
		final SettingsDialogBox gui = new SettingsDialogBox();
		JButton optionsButton = SlickerFactory.instance().createButton("Alignment weights");
		optionsButton.setToolTipText("Set alignment weights");
		optionsButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				EventQueue.invokeLater(new Runnable() {
					@Override
					public void run() {
						gui.loadFormValues();
						gui.setVisible(true);
					}
				});
			}
		});
		return optionsButton;
	}

	public static Map<String, Integer> getWeights() {
		return weights;
	}

	public static void setWeights(Map<String, Integer> weights) {
		RepairModel.weights = weights;
	}

	public static List<RepairBox> getRepairs() {
		return repairs;
	}

	public static void setRepairs(List<RepairBox> repairs) {
		RepairModel.repairs = repairs;
	}

	public static JComboBox getActToRepair() {
		return actToRepair;
	}

	public static void setActToRepair(JComboBox actToRepair) {
		RepairModel.actToRepair = actToRepair;
	}

	public static RepairStatsPanel getRepairStatsPanel() {
		return repairStatsPanel;
	}

	public static void setRepairStatsPanel(RepairStatsPanel repairStatsPanel) {
		RepairModel.repairStatsPanel = repairStatsPanel;
	}

	public static boolean addMissingActs() {
		return add.isSelected();
	}

	public static boolean removeExtraActs() {
		return remove.isSelected();
	}

}
