package org.processmining.dataquality;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.EmptyBorder;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;

import prefuse.util.ColorLib;

public class SettingsDialogBox extends JDialog {

	private static final long serialVersionUID = 1L;

	// Look
	private final Font titleFont = new Font("Arial", Font.BOLD, 13);

	// Components
	// Layout options
	private final JPanel contentPanel = new JPanel();
	//	private final JCheckBox chckbxEnabledFirstStages;
	//	private final JComboBox<LayeringStrategy> cbLayeringStrategy;
	//	private final JComboBox<LayoutOrientation> cbLayoutOrientation;
	//	private final JCheckBox chckbxEnableSimplifier;
	//	private final JCheckBox chckbxSimplifyAll;
	//	private final JCheckBox chckbxSimplifyLongEdges;
	//	private final JSpinner spCrossingThreshold;
	//	private final JSpinner spTotalCrossings;
	//	private final JSpinner spMaxLoops;
	//	private final JCheckBox chckbxSimplifySameLayer;
	//	private final JCheckBox chckbxReorderNodes;
	//	private final JSpinner spIntracellSpacing;
	//	private final JSpinner spLayerSpacing;
	//	private final JSpinner spEdgeLandingOffset;
	//	private final JComboBox<SequencingStrategy> cbSequencingStrategy;
	//	private final JComboBox<EmplacingStrategy> cbEmplacingStrategy;
	//	private final JComboBox<LineType> cbLineType;
	//	private final JCheckBox chckbxEdgeDirection;
	//	private final JCheckBox chckbxBarDrawing;

	// Other options
	//	private final JSpinner spTransitionsWidth;
	//	private final JSpinner spTransitionsHeight;
	//	private final JCheckBox chckbxTransitionsInOutDegree;
	//	private final JSpinner spPlacesWidth;
	//	//    private final JSpinner spPlacesHeight;
	//	private final JSpinner spFontSize;
	//	private final JSpinner spDegreeFontSize;
	//	private final JSpinner spAnimationLength;

	// Colors
	private Color edgeColor;
	private Color strokeColor;

	private List<JLabel> tranNames;
	private List<JTextField> values;

	// Controller
	private final PNetVisualizerController controller = PNetVisualizerController.getInstance();

	/**
	 * Create the dialog.
	 */
	public SettingsDialogBox() {
//		super(root);
		addEscapeListener(this);
		setMinimumSize(new Dimension(400, 700));
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		setTitle("Petri net viewer");
		setBounds(100, 100, 293, 700);
		setLocationRelativeTo(null);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new GridBagLayout());
		
		
		setAlwaysOnTop(true);

		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton btnSaveApply = new JButton("Apply");
				btnSaveApply.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						saveChanges();
					}
				});
				buttonPane.add(btnSaveApply);
			}
			{
				JButton okButton = new JButton("Apply & Save");
				okButton.setActionCommand("OK");
				okButton.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						saveChanges();
						setVisible(false);
					}
				});
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Close");
				cancelButton.setActionCommand("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					@Override
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				buttonPane.add(cancelButton);
			}
		}

//		loadFormValues();
	}

	public void loadFormValues() {
		tranNames = new ArrayList<JLabel>();
		values = new ArrayList<JTextField>();
		
		tranNames.clear();
		values.clear();
		contentPanel.removeAll();
		
		int i = 0;
		for (String s : controller.getIPN().getDqModel().getRepairModel().weights.keySet()) {
			tranNames.add(i, new JLabel(s));
			values.add(i, new JTextField(controller.getIPN().getDqModel().getRepairModel().weights.get(s).toString()));
			i++;
		}
		GridBagConstraints gbc = new GridBagConstraints();
		for (i = 0; i < tranNames.size(); i++) {
			gbc.gridy = i+1;
			gbc.gridx = 1;
			contentPanel.add(tranNames.get(i), gbc);
			gbc.gridx = 2;
			contentPanel.add(values.get(i), gbc);
		}
		// Layout options
		//		chckbxEnabledFirstStages.setSelected(controller.isFirstStagesEnabled());
		//		cbLayeringStrategy.setSelectedItem(controller.getLayeringStrategy());
		//		cbSequencingStrategy.setSelectedItem(controller.getSequencingStrategy());
		//		setFirstStagesEnabled(controller.isFirstStagesEnabled());
		//		chckbxEnableSimplifier.setSelected(controller.isSimplifierEnabled());
		//		chckbxSimplifyAll.setSelected(controller.isSimplifyShortEdgesEnabled());
		//		chckbxSimplifyLongEdges.setSelected(controller.isSimplifyLongEdgesEnabled());
		//		chckbxEdgeDirection.setSelected(controller.isEdgeDirectionEnabled());
		//		chckbxBarDrawing.setSelected(controller.isBarDrawingEnabled());
		//		spCrossingThreshold.setValue(controller.getSimplifierCrossingThreshold());
		//		spTotalCrossings.setValue(controller.getSimplifierTotalCrossingThreshold());
		//		spMaxLoops.setValue(controller.getSimplifierMaxLoops());
		//		chckbxSimplifySameLayer.setSelected(controller.isSimplifySameLayer());
		//		chckbxReorderNodes.setSelected(controller.isReorderNodesEnabled());
		//		setSimplifierPropertiesEnabled(controller.isSimplifierEnabled());
		//		spIntracellSpacing.setValue(controller.getIntracellSpacing());
		//		spLayerSpacing.setValue(controller.getLayerSpacing());
		//		spEdgeLandingOffset.setValue(controller.getEdgeLandingOffset());
		//		cbLayoutOrientation.setSelectedItem(controller.getLayoutOrientation());
		//		cbEmplacingStrategy.setSelectedItem(controller.getEmplacingStrategy());
		//		cbLineType.setSelectedItem(controller.getLineType());

		// Other options
		//		spTransitionsWidth.setValue(controller.getTransitionsWidth());
		//		spTransitionsHeight.setValue(controller.getTransitionsHeight());
		//		chckbxTransitionsInOutDegree.setSelected(controller.isTransitionsInOutDegreeEnabled());
		//		spPlacesWidth.setValue(controller.getPlacesSize());
		//		spFontSize.setValue(controller.getFontSize());
		//		spDegreeFontSize.setValue(controller.getDegreeFontSize());
		//		spAnimationLength.setValue(controller.getAnimationLength());

		// Colors
		edgeColor = ColorLib.getColor(controller.getEdgeColor());
		strokeColor = ColorLib.getColor(controller.getStrokeColor());
	}

	private void saveChanges() {
		//TODO save the new weights
		for (int i = 0; i < tranNames.size(); i++) {
			controller.getIPN().getDqModel().getRepairModel().weights.put(tranNames.get(i).getText(),
					Integer.valueOf(values.get(i).getText()));

		}
	}

	private void setSimplifierPropertiesEnabled(boolean enabled) {
		//		chckbxSimplifyAll.setEnabled(enabled);
		//		chckbxSimplifyLongEdges.setEnabled(enabled);
		//		chckbxEdgeDirection.setEnabled(enabled);
		//		chckbxBarDrawing.setEnabled(enabled);
		//		spCrossingThreshold.setEnabled(enabled);
		//		spTotalCrossings.setEnabled(enabled);
		//		spMaxLoops.setEnabled(enabled);
		//		chckbxSimplifySameLayer.setEnabled(enabled);
		//		chckbxReorderNodes.setEnabled(enabled);
		//
		//		if (enabled) {
		//			setSimplifyShortLongPropertiesEnabled(chckbxSimplifyAll.isSelected()
		//					|| chckbxSimplifyLongEdges.isSelected());
		//		}

		//
		//		if (!enabled) {
		//			chckbxSimplifyAll.setSelected(false);
		//			chckbxSimplifyLongEdges.setSelected(false);
		//			chckbxEdgeDirection.setSelected(false);
		//			chckbxBarDrawing.setSelected(false);
		//			chckbxSimplifySameLayer.setSelected(false);
		//			chckbxReorderNodes.setSelected(false);
		//		}
	}

	private void setSimplifyShortLongPropertiesEnabled(boolean enabled) {
		//		spCrossingThreshold.setEnabled(!enabled);
		//		spTotalCrossings.setEnabled(!enabled);
		//		spMaxLoops.setEnabled(!enabled);
		//		chckbxSimplifySameLayer.setEnabled(!enabled);
	}

	private void setFirstStagesEnabled(boolean enabled) {
		//		cbLayeringStrategy.setEnabled(enabled);
		//		cbSequencingStrategy.setEnabled(enabled);
	}

	public static void addEscapeListener(final JDialog dialog) {
		ActionListener escListener = new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				dialog.setVisible(false);
			}
		};
		dialog.getRootPane().registerKeyboardAction(escListener, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0),
				JComponent.WHEN_IN_FOCUSED_WINDOW);
	}
}
