package org.processmining.discovery;

import java.awt.Dimension;
import java.util.Set;

import javax.swing.JTabbedPane;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetArrayFactory;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
import org.processmining.acceptingpetrinet.plugins.VisualizeAcceptingPetriNetPlugin;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.alignments.ClusterNet;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.conversion.ProcessTree2Petrinet;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.InvalidProcessTreeException;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.NotYetImplementedException;
import org.processmining.processtree.conversion.ProcessTree2Petrinet.PetrinetWithMarkings;
import org.processmining.reduction.Reduction;

public class LongTermDependency {

	public static JTabbedPane getArray(InteractivePetriNet ipn, int w, int h) {
		Set<ProcessTree> pts = findLongTermDependencies(ipn);
		AcceptingPetriNetArray apn = AcceptingPetriNetArrayFactory.createAcceptingPetriNetArray();
		for (ProcessTree pt : pts) {
			PetrinetWithMarkings pn = null;
			try {
				pn = ProcessTree2Petrinet.convert(pt);
			} catch (NotYetImplementedException e) {
				e.printStackTrace();
			} catch (InvalidProcessTreeException e) {
				e.printStackTrace();
			}
			apn.addNet(new AcceptingPetriNetImpl(pn.petrinet));
		}

		VisualizeAcceptingPetriNetPlugin visualizer = new VisualizeAcceptingPetriNetPlugin();
		JTabbedPane tabbedPane = new JTabbedPane();
		tabbedPane.setPreferredSize(new Dimension(w, h));
		for (int index = 0; index < apn.getSize(); index++) {
			//			visualize(context, nets, index, visualizer, tabbedPane);
			String label = "Rank " + (index + 1);
			tabbedPane.add(label, visualizer.visualize(ipn.getContext(), apn.getNet(index)));
		}

		return tabbedPane;
	}

	private static Set<ProcessTree> findLongTermDependencies(InteractivePetriNet ipn) {
		PetriNetMap pnmap = new PetriNetMap(ipn.getselectedPetriNetMap().getPetriNet());
		ClusterNet cnet = new ClusterNet(pnmap);
		Reduction rd = new Reduction(pnmap.getPetriNet(), cnet);
		for (Transition t : cnet.getTranCluster().keySet()) {
			System.out.println("Tran clusters : " + t + cnet.getTranCluster().get(t));
		}

		return null;
	}

}
