package org.processmining.discovery;

import java.util.Map;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class SyncReplayAnalysis {
	private Map<Set<Place>, Integer> logMovePlaces;
	private Map<Transition, Integer> syncTrans;
	private int maxNbrOfLogMoves = 0, minNbrOfLogMoves = 99, averageNbrOfLogMoves = 0;

	public SyncReplayAnalysis(Map<Set<Place>, Integer> logMovesPlacesCount, Map<Transition, Integer> syncTrans2,
			int maxNbrOfLogMoves2, int minNbrOfLogMoves2, int averageNbrOfLogMoves2) {
		setMaxNbrOfLogMoves(maxNbrOfLogMoves2);
		setMinNbrOfLogMoves(minNbrOfLogMoves2);
		setLogMovePlaces(logMovesPlacesCount);
		setSyncTrans(syncTrans2);
		setAverageNbrOfLogMoves(averageNbrOfLogMoves2);
	}

	public int getMaxNbrOfLogMoves() {
		return maxNbrOfLogMoves;
	}

	public void setMaxNbrOfLogMoves(int maxNbrOfLogMoves) {
		this.maxNbrOfLogMoves = maxNbrOfLogMoves;
	}

	public int getMinNbrOfLogMoves() {
		return minNbrOfLogMoves;
	}

	public void setMinNbrOfLogMoves(int minNbrOfLogMoves) {
		this.minNbrOfLogMoves = minNbrOfLogMoves;
	}

	public int getAverageNbrOfLogMoves() {
		return averageNbrOfLogMoves;
	}

	public void setAverageNbrOfLogMoves(int averageNbrOfLogMoves) {
		this.averageNbrOfLogMoves = averageNbrOfLogMoves;
	}

	public Map<Set<Place>, Integer> getLogMovePlaces() {
		return logMovePlaces;
	}

	public void setLogMovePlaces(Map<Set<Place>, Integer> logMovePlaces) {
		this.logMovePlaces = logMovePlaces;
	}

	public Map<Transition, Integer> getSyncTrans() {
		return syncTrans;
	}

	public void setSyncTrans(Map<Transition, Integer> syncTrans) {
		this.syncTrans = syncTrans;
	}
}
