package org.processmining.discoverycontest.layout;

import java.util.HashMap;
import java.util.Map;

import org.processmining.datapetrinets.expression.GuardExpression;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PNWDTransition;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;

public class ExtractGuards {

	public static Map<String, String> extract(PetriNetWithData pnd) {
		
		Map<String,String> guards = new HashMap<String,String>();
		for (Transition t : pnd.getTransitions()) {
			GuardExpression guard = ((PNWDTransition) t).getGuardExpression();
			if (guard != null) {
				String str = guard.toCanonicalString();
				String strOnEdge = "";
				//check if the guard contains text NEXT/PREV 
				if (str.contains("NEXT")) {
					String[] strArr = str.split("NEXT");
					strOnEdge += strArr[1];
				}
				if (str.contains("PREV")) {
					String[] strArr = str.split("PREV");
					if (strOnEdge != "")
						strOnEdge += " , ";
					strOnEdge += strArr[1];
				}

				System.out.println(strOnEdge);
				guards.put(t.getLabel(), guard.toCanonicalString());
			}
		}
		
		return guards;
	}
}
