package org.processmining.discoverycontest.layout;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
import org.processmining.acceptingpetrinetreductionlayouter.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;

@Plugin(name = "BPMN Petri Net using Block Layout", level = PluginLevel.Regular, returnLabels = { "Block Layout View on Net" }, returnTypes = { JComponent.class }, parameterLabels = { "Petri Net With Data" }, userAccessible = true)
@Visualizer
public class PnToBPMNPluging {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, PetriNetWithData pnd) {
		Petrinet net1 = DataPetriNet.Factory.toPetrinet(pnd);
		PetriNetMap pnmap = new PetriNetMap((Petrinet) net1);
		Petrinet net = pnmap.getPetriNet();
		PetrinetToBPMN pbpm = new PetrinetToBPMN((Petrinet) net, null);

		boolean compact = true;
		BPMNUtils.removeNodes(pbpm, (Petrinet) net);
//		BPMNUtils.updateSilentLabels(pbpm, (Petrinet) net);
		BPMNUtils.addSilentPrePostSplitJoins((Petrinet) net);
		BPMNUtils.makeIORsVisible(pbpm, (Petrinet) net);
		AcceptingPetriNet pn = new AcceptingPetriNetImpl((Petrinet) net);
		LayoutAlgorithmReductionRules lar = new LayoutAlgorithmReductionRules();
		LayoutParameters parameters = new LayoutParameters();
		if (compact) {
			parameters.setHorizontalSpace(0);
			parameters.setVerticalSpace(60);

		}
		lar.apply(pn, parameters);

		for (Transition t : lar.getWs().net.getNet().getTransitions()) {
			System.out.println(lar.getXY(t));
		}
		pbpm = new PetrinetToBPMN(lar.getWs().net.getNet(), pnd);
		JPanel panel = new JPanel(new BorderLayout());
		panel.removeAll();
		JPanel panel2 = BPMNGraph.getLogView(lar, pbpm);
		panel.add(panel2, BorderLayout.CENTER);
		panel.revalidate();
		panel.repaint();

		
		return panel;
	}

	public LayoutParameters getParameters() {
		return new LayoutParameters();
	}
}
