package org.processmining.discoverycontest.layout;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
import org.processmining.acceptingpetrinetreductionlayouter.parameters.LayoutParameters;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

@Plugin(name = "Visualize2 Petri Net using Block Layout", level = PluginLevel.Regular, returnLabels = { "Block Layout View on Net" }, returnTypes = { JComponent.class }, parameterLabels = { "Petri Net" }, userAccessible = true)
@Visualizer
public class VisualizePlugin  {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, Petrinet net) {

		AcceptingPetriNet pn = new AcceptingPetriNetImpl(net);
		LayoutAlgorithmReductionRules lar = new LayoutAlgorithmReductionRules();
		lar.apply(pn, new LayoutParameters());

		System.out.println("here we are");
		
		for (Transition t : lar.getWs().net.getNet().getTransitions()) {
			System.out.println(lar.getXY(t));
		}

		JPanel panel =new JPanel(new BorderLayout());
		panel.removeAll();
		panel.add(BPMNGraph.getLogView(lar,null), BorderLayout.CENTER);
		panel.revalidate();
		panel.repaint();
		return panel;
	}

	public LayoutParameters getParameters() {
		return new LayoutParameters();
	}
}
