package org.processmining.exhaustivesearch;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.experiments.SynthesizeNets;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.fcnets.expansion.ExpansionUtils;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtils;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.synthesis.CreateIPN;
import org.processmining.prabhakardixit.fcnets.synthesis.VizToPnetMapper;
import org.processmining.reduction.ReductionTracker;

@Plugin(name = "Petrinet with compare ", parameterLabels = { "X" }, returnLabels = { "Petri net" }, returnTypes = { Petrinet.class })
public class LogInput {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public Petrinet yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {
		String analysisResults = "Analysis\n";
		String issApproach = "ISS Analysis\r\n";
		StringBuilder debugInfo = new StringBuilder("Debugger\r\n");
		for (int nbrOfNets = 0; nbrOfNets < 1; nbrOfNets++) {
			analysisResults += ("\r\n");
			StringBuilder prevDebugInfo = new StringBuilder("Debugger\r\n");
			String results = "";
			VizToPnetMapper.log = false;
			stop = false;
			long timeNow = System.currentTimeMillis();
			InteractivePetriNet ipn = CreateIPN.createIPN(log, context, false, false, true);
			MatrixUtils.initiate(ipn);
			Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
			Random random = new Random();

			int k = 0;
			for (int j = 0; j < 1; j++) {
				int parPlacs = 10;//29;//bpic= 5*3;
				int choiceTrans = 11;//50; //bpic= 19*3;
				int seqUences = 11;//65;//bpic= 24*3;
				int iMax = 20;
				for (int i = 0; i < iMax; i++) {
					boolean contains = false;
					k += 1;
					int opType = random.nextInt(5);

					while (!contains) {
						if (i == 0) //start with seq
							opType = 3;
						else
							opType = random.nextInt(5);
						//					
						//					if(i <35 && opType == 0)
						//						opType = 5;

						switch (opType) {
							case 0 :
								if (parPlacs > 0) {
									contains = true;
									parPlacs--;
								}
								break;
							case 1 :
								if (choiceTrans > 0) {
									contains = true;
									choiceTrans--;
								}
								break;
							case 2 :
							case 3 :
								if (seqUences > 0) {
									contains = true;
									seqUences--;
								}
								break;
						}
					}
					timeNow = System.currentTimeMillis();

					switch (opType) {
						case 0 :
							SynthesizeNets.addParallelPlace(ipn);
							break;
						case 1 :
							SynthesizeNets.addChoiceTran(ipn);
							break;
						case 2 :
							SynthesizeNets.addSequence(ipn, 1);
							break;
						case 3 :
							SynthesizeNets.addSequence(ipn, 2);
							break;
						case 4 :
							SynthesizeNets.addChoiceTran(ipn);
							break;
						default :
							SynthesizeNets.addSequence(ipn, 2);
							break;
					}
					timeNow = System.currentTimeMillis() - timeNow;
					//					System.out.println("Iteration: " + k + " Op Type: " + opType + " # trans : "
					//							+ pn.getTransitions().size() + " # places " + pn.getPlaces().size()
					//							+ " Size of place ld mat : " + ipn.getAllLdPlaceInfo().size() + " Size of tran ld mat : "
					//							+ ipn.getAllLdTranInfo().size() + " Size of place ld FC mat : "
					//							+ ipn.getplaceLDNonSiphons().size() + " Size of tran ld FC non Sip mat : "
					//							+ ipn.getTranLDFCs().size() + " time diff in millis "
					//							+ (System.currentTimeMillis() - timeNow));
					//			}

					//add to prevDebugInfo
					ReductionTracker rd = ipn.getInteractiveMatNet().getCurrentRedTracker();
					prevDebugInfo.append(ExpansionUtils.logger(rd));

					//compare
					long timeTaken = System.currentTimeMillis();
					ExhaustiveInfo ei = CompareExhaustiveIncrementalApproach.getExhaustiveInfo(context,
							ipn.getInteractiveMatNet());
					timeTaken = System.currentTimeMillis() - timeTaken;
					if (CompareExhaustiveIncrementalApproach.compare(ipn.getInteractiveMatNet(), ei)) {
						results += " TRUE ";
						analysisResults += ("\r\nNet # : " + nbrOfNets + " ,Iteration # : " + k + " ,ExhaustiveTime(ms) " + timeTaken);
						issApproach += ("\r\nNet # : " + nbrOfNets + " ,Iteration # : " + k + " ,ISS(ms) " + timeNow);
					} else {
						debugInfo.append("\r\n FALSE : ");
						debugInfo.append("\r\n");
						debugInfo.append(prevDebugInfo);
						System.err.println("FALSE HAPPENED");
						results += " FALSE ";
					}

				}
			}
			System.out.println(" ------------- xxx Results : " + results);
		}
		try {
			PrintWriter writer = new PrintWriter("Analysis_2707.txt", "UTF-8");
			writer.println(analysisResults);
			writer.print(issApproach);
			writer.println(debugInfo);
			writer.close();
		} catch (IOException e) {
			// do something
		}
		return null;
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0 })
	public Petrinet yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {

		return yourPrivatePlugin(context, log);

	}
}
