package org.processmining.experiments;

import java.util.HashSet;
import java.util.Random;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtils;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.synthesis.CreateIPN;
import org.processmining.prabhakardixit.fcnets.synthesis.VizToPnetMapper;

@Plugin(name = "Expt Petri net genera1114tor", parameterLabels = { "Log " }, returnLabels = { "Name of your output" }, returnTypes = { InteractivePetriNet.class })
public class CopyOfLogInput {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public InteractivePetriNet yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {
		//AcceptingPetriNetArray apn =  tempRun.temprun(pn);
		//PetriNetMap pnMap = new PetriNetMap(pn);
		//List<PetriNetMap> pnMapList=  tempRun.temprun(pnMap);
		//List<PetriNetMap> pnMapList=  org.processmining.prabhakardixit.fcnets.synthesis.SynthesisTempRun.temprun(pnMap);
		//VisualizeAcceptingPetriNetArrayPlugin a = new VisualizeAcceptingPetriNetArrayPlugin();
		//a.visualize(context, apn);
		//InteractivePetriNet ipn = new InteractivePetriNet(pnMapList, "");
		//ipn.setAcceptingPetriNetArray(apn);
		//CalculateLogHeuristics.calculateRelations(log);
		stop = false;
		long timeNow = System.currentTimeMillis();
		InteractivePetriNet ipn = CreateIPN.createIPN(log, context, false, false, true);
		MatrixUtils.initiate(ipn);
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		Random random = new Random();
		int iMax = 35;
		int i = 0;
		String activity = "";
		String newTransStr = "";
		String newPlaceStr = "";
		boolean placeToTran;
		int newPlaceID;
		int newTranID;
		boolean isSilent;

		VizToPnetMapper.log = false;

		Set<Integer> start = new HashSet<Integer>();
		Set<Integer> end = new HashSet<Integer>();

		start.clear(); end.clear();
		start.add(0);
		end.add(1);
		newTransStr=""; placeToTran=false ; newPlaceStr=""; newPlaceID=29; newTranID=33; isSilent=true;
		VizToPnetMapper.addNewTransition(start, end, newTransStr,newPlaceStr, ipn,placeToTran,newPlaceID,newTranID, isSilent);
		start.clear(); end.clear();
		start.add(0);
		end.add(1);
		newPlaceStr="newPlace"; newPlaceID=30; 
		VizToPnetMapper.addParallelPlace(start, end, newPlaceStr, ipn, newPlaceID);
		start.clear(); end.clear();
		start.add(0);
		end.add(1);
		newPlaceStr="newPlace"; newPlaceID=31; 
		VizToPnetMapper.addParallelPlace(start, end, newPlaceStr, ipn, newPlaceID);
		start.clear(); end.clear();
		start.add(0);
		end.add(29);
		end.add(30);
		end.add(31);
		newTransStr=""; placeToTran=false ; newPlaceStr=""; newPlaceID=32; newTranID=34; isSilent=true;
		VizToPnetMapper.addNewTransition(start, end, newTransStr,newPlaceStr, ipn,placeToTran,newPlaceID,newTranID, isSilent);
		start.clear(); end.clear();
		start.add(0);
		end.add(1);
		newPlaceStr="newPlace"; newPlaceID=33; 
		VizToPnetMapper.addParallelPlace(start, end, newPlaceStr, ipn, newPlaceID);
		start.clear(); end.clear();
		start.add(32);
		end.add(1);
		end.add(30);
		end.add(31);
		activity=""; newTranID=35; isSilent=true;
		VizToPnetMapper.addChoiceTransition(start, end, activity, ipn,newTranID, isSilent);
		start.clear(); end.clear();
		start.add(34);
		start.add(35);
		end.add(1);
		newPlaceStr="newPlace"; newPlaceID=34; 
		VizToPnetMapper.addParallelPlace(start, end, newPlaceStr, ipn, newPlaceID);
		start.clear(); end.clear();
		start.add(0);
		end.add(32);
		end.add(33);
		newTransStr=""; placeToTran=false ; newPlaceStr=""; newPlaceID=35; newTranID=36; isSilent=true;
		VizToPnetMapper.addNewTransition(start, end, newTransStr,newPlaceStr, ipn,placeToTran,newPlaceID,newTranID, isSilent);
		start.clear(); end.clear();
		start.add(1);
		start.add(33);
		start.add(34);
		start.add(30);
		start.add(31);
		end.add(35);
		activity=""; newTranID=37; isSilent=true;
		VizToPnetMapper.addChoiceTransition(start, end, activity, ipn,newTranID, isSilent);
		start.clear(); end.clear();
		start.add(33);
		start.add(35);
		end.add(1);
		newTransStr=""; placeToTran=false ; newPlaceStr=""; newPlaceID=36; newTranID=38; isSilent=true;
		VizToPnetMapper.addNewTransition(start, end, newTransStr,newPlaceStr, ipn,placeToTran,newPlaceID,newTranID, isSilent);


		//printStats(i, 0, ipn, timeNow);
		//		System.out.println(ipn.getIncidenceMatrixInput().plus(ipn.getIncidenceMatrixOutput()));
		//		System.out.println(ipn.getTranceChoiceAll());
		//		for(Integer key : ipn.getPlaceParallelMapAll().keySet()){
		//			System.out.println(key+ "  ; "+ ipn.getPlaceParallelMapAll().get(key));
		//		}

		return ipn;
	}

	private void printStats(int i, int opType, InteractivePetriNet ipn, long timeNow) {
		System.out.println("Iteration: " + i + " Op Type: " + opType + " # trans : "
				+ ipn.getselectedPetriNetMap().getPetriNet().getTransitions().size() + " # places "
				+ ipn.getselectedPetriNetMap().getPetriNet().getPlaces().size() + " Size of place ld mat : "
				+ ipn.getAllLdPlaceInfo().size() + " Size of tran ld mat : " + ipn.getAllLdTranInfo().size()
				+ " time diff in millis " + (System.currentTimeMillis() - timeNow));
	}

	//	private void addChoice(Set<Integer> startChoice, Set<Integer> endChoice, InteractivePetriNet ipn) {
	//		VizToPnetMapper.addChoiceTransition(startChoice, endChoice, "", ipn);
	//
	//	}
	//
	//	private void addPP(Set<Integer> i, Set<Integer> j, InteractivePetriNet ipn) {
	//
	//		VizToPnetMapper.addParallelPlace(i, j,
	//				String.valueOf(ipn.getselectedPetriNetMap().getPetriNet().getPlaces().size()), ipn);
	//
	//	}
	//
	//	private void addSeq(Set<Integer> i, Set<Integer> j, InteractivePetriNet ipn) {
	//
	//		VizToPnetMapper.addNewTransition(i, j, "", ipn, false);
	//
	//	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0 })
	public InteractivePetriNet yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {

		return yourPrivatePlugin(context, log);

	}
}
