package org.processmining.experiments;

import java.util.ArrayList;
import java.util.Collection;

import org.apache.commons.math3.optim.MaxIter;
import org.apache.commons.math3.optim.PointValuePair;
import org.apache.commons.math3.optim.linear.LinearConstraint;
import org.apache.commons.math3.optim.linear.LinearConstraintSet;
import org.apache.commons.math3.optim.linear.LinearObjectiveFunction;
import org.apache.commons.math3.optim.linear.NonNegativeConstraint;
import org.apache.commons.math3.optim.linear.Relationship;
import org.apache.commons.math3.optim.linear.SimplexSolver;
import org.apache.commons.math3.optim.nonlinear.scalar.GoalType;

public class Demo {
	public static void main(String[] args) {

		LinearObjectiveFunction f = new LinearObjectiveFunction(new double[] { 1, 1, 1 }, 0);
		Collection<LinearConstraint> constraints = new ArrayList<LinearConstraint>();
		constraints.add(new LinearConstraint(new double[] { 1, 1, 1 }, Relationship.EQ, 1));
		constraints.add(new LinearConstraint(new double[] { 1, 0, 1 }, Relationship.EQ, 1));
		constraints.add(new LinearConstraint(new double[] { 0, 1, 0 }, Relationship.EQ, 0));
		SimplexSolver solver = new SimplexSolver();
		PointValuePair solution = solver.optimize(new MaxIter(100), f, new LinearConstraintSet(constraints),
				GoalType.MINIMIZE, new NonNegativeConstraint(true));
		//		 solution = solution.getPoint();
		System.out.println(solution.getPoint());

	}
}
