package org.processmining.expts;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class BruteForceComputation {

	public static void computeBF(Petrinet pn, Map<Byte, Place> placeIdMap, Map<Byte, Transition> tranIdMap) {
		byte[] chars = { -1, 0, 1 };
		Set<byte[]> ttComb = Permutations.permute(chars, pn.getPlaces().size());
		Set<byte[]> ppComb = Permutations.permute(chars, pn.getTransitions().size());

		for (byte[] b : ttComb) {
			Set<Place> negatives = new HashSet<Place>();
			Set<Place> positives = new HashSet<Place>();
			for (byte j = 0; j < pn.getPlaces().size(); j++) {
				if (b[j] == -1) {
					negatives.add(placeIdMap.get(j));
				} else if (b[j] == 1)
					positives.add(placeIdMap.get(j));
			}
			VectorUtils.isLinearlyDependentTran(pn, b, placeIdMap, tranIdMap);
			VectorUtils.isFCTransVector(pn, negatives, positives);
		}

		for (byte[] b : ppComb) {
			Set<Transition> negatives = new HashSet<Transition>();
			Set<Transition> positives = new HashSet<Transition>();
			for (byte j = 0; j < pn.getTransitions().size(); j++) {
				if (b[j] == -1)
					negatives.add(tranIdMap.get(j));
				else if (b[j] == 1) {
					positives.add(tranIdMap.get(j));
				}
			}
			VectorUtils.isLinearlyDependentPlace(pn, b, placeIdMap, tranIdMap);
			VectorUtils.isFCPlaceVector(pn, negatives, positives);
		}

	}
}
