package org.processmining.expts;

import java.util.HashSet;
import java.util.Set;

public class Permutations {

	public static Set<byte[]> permute(byte[] chars, int k) {
		int n = chars.length;
		Set<byte[]> perms1 = new HashSet<byte[]>();
		int[] indexes = new int[k];
		int total = (int) Math.pow(n, k);

		while (total-- > 0) {
			byte[] snapshot = new byte[k];
			for (int i = 0; i < k; i++) {
				snapshot[i] = chars[indexes[i]];
			}
			//			callback.handle(snapshot);
			perms1.add(snapshot);
			//			perms.add(snapshot);
			for (int i = 0; i < k; i++) {
				if (indexes[i] >= n - 1) {
					indexes[i] = 0;
				} else {
					indexes[i]++;
					break;
				}
			}
		}
		return perms1;
	}

	public static interface PermuteCallback {
		public void handle(Object[] snapshot);
	};

	public static void main(String[] args) {
		byte[] chars = { -1, 0, 1 };

		doPermutation(chars, 4);
	}

	public static void doPermutation(byte[] chars, int size) {
		Set<byte[]> perms1 = permute(chars, size);

		for (byte[] snapshot : perms1) {
			for (int i1 = 0; i1 < snapshot.length; i1++) {
				System.out.print(snapshot[i1]);
			}
			System.out.println();
		}
		
	}
}
