package org.processmining.humbertogarciacaballero.models.gui.action;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.data.Tuple;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.AggregateItem;
import prefuse.visual.AggregateTable;
import prefuse.visual.VisualItem;

public class AggregateNodesBySimplifiedLayer extends AggregateNodesByLayer {

    public AggregateNodesBySimplifiedLayer(String group, AggregateTable aggregateTable) {
        super(group, aggregateTable);
    }

    @SuppressWarnings("unchecked")
    @Override
    public void run(double frac) {
        TupleSet ts = getVisualization().getGroup(getGroup());
        int maxLayer = getMaxLayer(ts);

        for (int i = 0; i <= maxLayer; i++) {
            AggregateItem aggregateItem = getAggregate(i);
            aggregateItem.removeAllItems();
            Iterator<Tuple> iter = ts.tuples(ExpressionParser.predicate(
                    "[" + PNConstants.SIMPLIFIED_KEY + "] == TRUE AND [" + PNConstants.NODE_LAYER_KEY + "] = " + i));
            if (iter.hasNext()) {
                while (iter.hasNext()) {
                    VisualItem vi = (VisualItem) iter.next();
                    if (!aggregateItem.containsItem(vi)) {
                        aggregateItem.addItem(vi);
                    }
                }
                aggregateItem.setInt(PNConstants.NODE_LAYER_KEY, i);
                aggregateItem.setInt(PNConstants.NODE_MAX_LAYER_KEY, maxLayer);
                aggregateItem.setBoolean(PNConstants.EDGE_LONG_EDGE_KEY, containsLongEdges(ts, i));
            }
        }
    }
}
