package org.processmining.humbertogarciacaballero.models.gui.action;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.action.assignment.ColorAction;
import prefuse.util.ColorLib;
import prefuse.visual.DecoratorItem;
import prefuse.visual.VisualItem;

public class TextColorAction extends ColorAction {

    public TextColorAction(String group) {
        super(group, VisualItem.TEXTCOLOR);
    }
    
    public int getColor(VisualItem item) {
        int color = PNConstants.FONT_COLOR;
        
        if (item instanceof DecoratorItem) {
            int backgroundColor = ((DecoratorItem)item).getDecoratedItem().getEndFillColor();
            int brightness = Math.round(((ColorLib.red(backgroundColor) * 299) + (ColorLib.green(backgroundColor) * 587) + (ColorLib.blue(backgroundColor) * 114)) /1000);
            
            if (brightness < 125) {
                color = PNConstants.FONT_COLOR_OPPOSITE;
            }
        }
        
        return color;
    }
}
