package org.processmining.humbertogarciacaballero.models.gui.components;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JPanel;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Visualization;
import prefuse.visual.NodeItem;

public class NodeHotboxComponent extends JPanel {
    
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    protected PNetVisualizerController controller;
    protected NodeItem item;
    protected Visualization vis;

    public NodeHotboxComponent(Visualization vis) {
        this.vis = vis;
        controller = PNetVisualizerController.getInstance();
    }
    
    public void setItem(NodeItem item) {
        this.item = item;
    }
    
    class CloseAction extends AbstractAction {
        public CloseAction() {
            super("Close", null);
            putValue(SHORT_DESCRIPTION, "Closes hotbox");
        }

        public void actionPerformed(ActionEvent e) {
        	item.setHighlighted(false);
        	Visualization vis = item.getVisualization();
        	vis.cancel(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
        	vis.run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
        	vis.run(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
            setVisible(false);
//            controller.setTooltipControlEnabled(true);
        }        
    }
    
    class HighlightNeighbours extends AbstractAction {
        public HighlightNeighbours(String text, ImageIcon icon, String desc, Integer mnemonic) {
            super(text, icon);
            putValue(SHORT_DESCRIPTION, desc);
            putValue(MNEMONIC_KEY, mnemonic);
        }

        public void actionPerformed(ActionEvent e) {
            setVisible(false);
        }        
    }

    public NodeItem getItem() {
        return item;
    }
}
