package org.processmining.humbertogarciacaballero.models.gui.decorator;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;

import prefuse.action.layout.Layout;
import prefuse.visual.DecoratorItem;
import prefuse.visual.VisualItem;

public class LabelDecoratorLayout extends Layout {

	public LabelDecoratorLayout(String group) {
		super(group);
	}

	@SuppressWarnings("unchecked")
	public void run(double frac) {
		synchronized (m_vis) {
			Iterator<DecoratorItem> iter = getVisualization().items(getGroup());
			while (iter.hasNext()) {
				DecoratorItem decorator = iter.next();
				VisualItem decoratedItem = decorator.getDecoratedItem();
				Rectangle2D bounds = decoratedItem.getBounds();

				double x = bounds.getCenterX();
				double y = bounds.getCenterY();

				setX(decorator, null, x);
				setY(decorator, null, y);
			}
		}
	}
}
