package org.processmining.humbertogarciacaballero.models.gui.decorator;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.util.Utils;

import prefuse.action.layout.Layout;
import prefuse.visual.DecoratorItem;
import prefuse.visual.VisualItem;

public class NodeDegreeLabelDecoratorLayout extends Layout {

	private PNetVisualizerController controller;
	private boolean indegrees;

	public NodeDegreeLabelDecoratorLayout(String group, boolean indegrees) {
		super(group);
		this.controller = PNetVisualizerController.getInstance();
		this.indegrees = indegrees;
	}

	public void run(double frac) {
		synchronized (m_vis) {
			@SuppressWarnings("unchecked")
			Iterator<DecoratorItem> iter = m_vis.items(m_group);
			while (iter.hasNext()) {
				DecoratorItem decorator = iter.next();
				VisualItem decoratedItem = decorator.getDecoratedItem();
				Rectangle2D bounds = decoratedItem.getBounds();
				float width = Utils.getWidth(decoratedItem);
				float height = Utils.getHeight(decoratedItem);
				double widthOffset = ((width / 2) - 1) / 2;
				double heightOffset = ((height * 3) / 10) / 2;

				double x;
				double y;

				if (indegrees) {
					switch (controller.getLayoutOrientation()) {
						case TOP_TO_BOTTOM :
							x = bounds.getX() + widthOffset;
							y = bounds.getY() + heightOffset;
							break;
						case BOTTOM_TO_TOP :
							x = bounds.getMaxX() - widthOffset;
							y = bounds.getMaxY() - heightOffset;
							break;
						case LEFT_TO_RIGHT :
							x = bounds.getX() + widthOffset;
							y = bounds.getMaxY() - heightOffset;
							break;
						default :
							x = bounds.getMaxX() - widthOffset;
							y = bounds.getY() + heightOffset;
							break;
					}
				} else {
					switch (controller.getLayoutOrientation()) {
						case TOP_TO_BOTTOM :
							x = bounds.getX() + widthOffset;
							y = bounds.getMaxY() - heightOffset;
							break;
						case BOTTOM_TO_TOP :
							x = bounds.getMaxX() - widthOffset;
							y = bounds.getY() + heightOffset;
							break;
						case LEFT_TO_RIGHT :
							x = bounds.getMaxX() - widthOffset;
							y = bounds.getMaxY() - heightOffset;
							break;
						default :
							x = bounds.getX() + widthOffset;
							y = bounds.getY() + heightOffset;
							break;
					}
				}

				setX(decorator, null, x);
				setY(decorator, null, y);
			}
		}
	}

}
