package org.processmining.humbertogarciacaballero.models.gui.decorator;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;
import org.processmining.humbertogarciacaballero.models.util.Utils;

import prefuse.action.layout.Layout;
import prefuse.data.util.Sort;
import prefuse.visual.AggregateItem;
import prefuse.visual.DecoratorItem;

public class TextBarDecoratorLayout extends Layout {
    
    private PNetVisualizerController controller;
    
    public TextBarDecoratorLayout(String group) {
        super(group);
        controller = PNetVisualizerController.getInstance();
    }

    @SuppressWarnings("unchecked")
    @Override
    public void run(double frac) {
        Iterator<DecoratorItem> iter = getVisualization().getGroup(getGroup()).tuples(null, new Sort(new String[]{PNConstants.NODE_LAYER_KEY}, new boolean[]{true}));
        
        DecoratorItem current = null, next = null;
        if (iter.hasNext()) {
            current = iter.next();
        }
        while (iter.hasNext()) {
            next = iter.next();
            AggregateItem decoratedItem = (AggregateItem) current.getDecoratedItem();
            Rectangle2D bounds = Utils.getBounds(decoratedItem);
            AggregateItem decoratedItem1 = (AggregateItem) next.getDecoratedItem();
            Rectangle2D bounds1 = Utils.getBounds(decoratedItem1);
            
            double x, y;
            switch (controller.getLayoutOrientation()) {
            case TOP_TO_BOTTOM:
            case BOTTOM_TO_TOP:
                x = Math.min(bounds.getMaxX(), bounds1.getMinX()) - PNConstants.BAR_TEXT_OFFSET;
                y = bounds.getMaxY() + ((bounds1.getMinY() - bounds.getMaxY()) / 2);
                break;
            default:
                x = bounds.getMaxX() + ((bounds1.getMinX() - bounds.getMaxX()) / 2);
                y = Math.min(bounds.getMinY(), bounds1.getMinY()) - PNConstants.BAR_TEXT_OFFSET;
                break;
            }
            
            setX(current, null, x);
            setY(current, null, y);
            
            current = next;
        }
    }

}
