package org.processmining.humbertogarciacaballero.models.gui.render;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Path2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.LinkedList;
import java.util.List;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Constants;
import prefuse.data.Node;
import prefuse.render.EdgeRenderer;
import prefuse.util.GraphicsLib;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class CustomEdgeRenderer extends EdgeRenderer {

	private Path2D path;

	public CustomEdgeRenderer() {
		super(prefuse.Constants.EDGE_TYPE_CURVE, prefuse.Constants.EDGE_ARROW_FORWARD);
		path = new GeneralPath();
	}

	/**
	 * @see prefuse.render.AbstractShapeRenderer#getRawShape(prefuse.visual.VisualItem)
	 */
	/*
	 * protected Shape getRawShape(VisualItem item) { LinkedList<Point2D> bends
	 * = (LinkedList<Point2D>) (item.get(PNConstants.EDGE_BENDS_KEY) != null ?
	 * new LinkedList<>( (List<Point2D>) item.get(PNConstants.EDGE_BENDS_KEY)) :
	 * new LinkedList<>()); EdgeItem edge = (EdgeItem) item; VisualItem item1 =
	 * edge.getSourceItem(); VisualItem item2 = edge.getTargetItem(); Node
	 * nTarget = edge.getTargetNode(); boolean swap = false; if
	 * (nTarget.getInDegree() > 1 || (nTarget.get("type") == "PLACE" &&
	 * nTarget.getOutDegree() > 1)) swap = true; //pmd
	 * 
	 * //pmd
	 * 
	 * int type = m_edgeType;
	 * 
	 * getAlignedPoint(m_tmpPoints[0], item1.getBounds(), m_xAlign1, m_yAlign1);
	 * getAlignedPoint(m_tmpPoints[1], item2.getBounds(), m_xAlign2, m_yAlign2);
	 * m_curWidth = (float) (m_width * getLineWidth(item)); // create the edge
	 * shape Shape shape = null; double n1x = m_tmpPoints[0].getX(); double n1y
	 * = m_tmpPoints[0].getY(); double n2x = m_tmpPoints[1].getX(); double n2y =
	 * m_tmpPoints[1].getY(); double dx = n2x - n1x, dy = n2y - n1y;
	 * 
	 * 
	 * 
	 * float[] pts = new float[bends.size() < 1 ? 6 : bends.size() * 2 + 4]; if
	 * (bends.size() < 1) { pts[0] = (float) n1x; pts[1] = (float) n1y; if
	 * (!swap) { // pts[2] = (float) ((n1x + n2x) / 2); pts[2] = (float) (n1x);
	 * pts[3] = (float) ((float) n2y); } else { double d2 = n2x > n1x ? n2x -
	 * n1x : n1x - n2x; // pts[2] = (float) (n1x + n2x) / 2; pts[2] = (float)
	 * (n2x); pts[3] = (float) ((float) n1y); } pts[4] = (float) n2x; pts[5] =
	 * (float) n2y; } else { int i = 2; pts[0] = (float) n1x; pts[1] = (float)
	 * n1y; for (Point2D b : bends) { pts[i] = (float) b.getX(); i++; pts[i] =
	 * (float) b.getY(); i++; } pts[i] = (float) n2x; i++; pts[i] = (float) n2y;
	 * 
	 * } // create the arrow head, if needed EdgeItem e = (EdgeItem) item;
	 * 
	 * if (e.isDirected() && m_edgeArrow != Constants.EDGE_ARROW_NONE) { // get
	 * starting and ending edge endpoints boolean forward = (m_edgeArrow ==
	 * Constants.EDGE_ARROW_FORWARD); Point2D start = null, end = null; start =
	 * m_tmpPoints[forward ? 0 : 1]; end = m_tmpPoints[forward ? 1 : 0];
	 * 
	 * // compute the intersection with the target bounding box VisualItem dest
	 * = forward ? e.getTargetItem() : e.getSourceItem(); int i =
	 * GraphicsLib.intersectLineRectangle(start, end, dest.getBounds(),
	 * m_isctPoints); if (i > 0) end = m_isctPoints[0]; //
	 * setArrowHeadSize(6,16);
	 * 
	 * start.setLocation((double) pts[pts.length - 1], pts[pts.length - 2]);
	 * end.setLocation((double) pts[pts.length - 3], pts[pts.length - 4]); //
	 * create the arrow head shape AffineTransform at = getArrowTrans(start,
	 * end, m_curWidth); m_curArrow = at.createTransformedShape(m_arrowHead);
	 * 
	 * // update the endpoints for the edge shape // need to bias this by arrow
	 * head size Point2D lineEnd = m_tmpPoints[forward ? 1 : 0];
	 * lineEnd.setLocation(0, -m_arrowHeight); at.transform(lineEnd, lineEnd); }
	 * else { m_curArrow = null; }
	 * 
	 * if (true) return GraphicsLib.cardinalSpline(pts, 0, bends.size() < 1 ? 3
	 * : bends.size() + 2, 0.1f, false);
	 * 
	 * //polyline ends
	 * 
	 * // } else { getCurveControlPoints(edge, m_ctrlPoints, n1x, n1y, n2x,
	 * n2y); // }
	 * 
	 * m_cubic.setCurve(n1x, n1y, m_ctrlPoints[0].getX(),
	 * m_ctrlPoints[0].getY(), m_ctrlPoints[1].getX(), m_ctrlPoints[1].getY(),
	 * n2x, n2y); shape = m_cubic; // return the edge shape return shape; }
	 */

	protected void drawShape(Graphics2D g, VisualItem item, Shape shape) {
		if (item.getBoolean("temp")){
			item.setStrokeColor(PNConstants.TEMP_NODES_EDGES_COLOR);
			g.setColor(Color.CYAN);
		}
		GraphicsLib.paint(g, item, shape, getStroke(item), getRenderType(item));

	}

	protected Shape getRawShape(VisualItem item) {
		LinkedList<Point2D> bends = (LinkedList<Point2D>) (item.get(PNConstants.EDGE_BENDS_KEY) != null ? new LinkedList<>(
				(List<Point2D>) item.get(PNConstants.EDGE_BENDS_KEY)) : new LinkedList<>());

		if (bends.size() == 0)
			return super.getRawShape(item);
		setDefaultLineWidth(2.);
		setArrowHeadSize(20, 30);
		setArrowType(Constants.EDGE_ARROW_FORWARD);
		EdgeItem edge = (EdgeItem) item;
		VisualItem item1 = edge.getSourceItem();
		VisualItem item2 = edge.getTargetItem();
		Node nTarget = edge.getTargetNode();
		boolean swap = false;
		if (nTarget.getInDegree() > 1 || (nTarget.get("type") == "PLACE" && nTarget.getOutDegree() > 1))
			swap = true;
		//pmd 

		//pmd

		int type = m_edgeType;

		getAlignedPoint(m_tmpPoints[0], item1.getBounds(), m_xAlign1, m_yAlign1);
		getAlignedPoint(m_tmpPoints[1], item2.getBounds(), m_xAlign2, m_yAlign2);
		m_curWidth = (float) (m_width * getLineWidth(item));
		// create the edge shape
		Shape shape = null;
		double n1x = m_tmpPoints[0].getX();
		double n1y = m_tmpPoints[0].getY();
		double n2x = m_tmpPoints[1].getX();
		double n2y = m_tmpPoints[1].getY();
		double dx = n2x - n1x, dy = n2y - n1y;

		//		float[] pts = new float[bends.size() < 99 ? 6 : bends.size() * 2 + 4];
		//		if (bends.size() < 99) {
		//			pts[0] = (float) n1x;
		//			pts[1] = (float) n1y;
		//			if (!swap) {
		//				//				pts[2] = (float) ((n1x + n2x) / 2);
		//				pts[2] = (float) ((float) (n1x));
		//				pts[3] = (float) ((float) n2y);
		//			} else {
		//				double d2 = n2x > n1x ? n2x - n1x : n1x - n2x;
		//				//				pts[2] = (float) (n1x + n2x) / 2;
		//				pts[2] = (float) (n2x);
		//				pts[3] = (float) ((float) n1y);
		//			}
		//			pts[4] = (float) n2x;
		//			pts[5] = (float) n2y;
		//		} else {
		//			int i = 2;
		//			pts[0] = (float) n1x;
		//			pts[1] = (float) n1y;
		//			for (Point2D b : bends) {
		//				pts[i] = (float) b.getX();
		//				i++;
		//				pts[i] = (float) b.getY();
		//				i++;
		//			}
		//			pts[i] = (float) n2x;
		//			i++;
		//			pts[i] = (float) n2y;
		//
		//		}
		// create the arrow head, if needed
		EdgeItem e = (EdgeItem) item;

		if (e.isDirected() && m_edgeArrow != Constants.EDGE_ARROW_NONE) {
			// get starting and ending edge endpoints
			boolean forward = (m_edgeArrow == Constants.EDGE_ARROW_FORWARD);
			Point2D start = null, end = null;
			start = bends.getLast();
			//			start = new Point2D.Double(pts[2], pts[3]);
			end = m_tmpPoints[1];

			// compute the intersection with the target bounding box
			VisualItem dest = item2;
			int i;
			if (dest.getShape() == Constants.SHAPE_DIAMOND) {
				i = intersectLineDiamond(start, end, dest.getBounds(), m_isctPoints);
			} else {
				i = GraphicsLib.intersectLineRectangle(start, end, dest.getBounds(), m_isctPoints);
			}

			if (i > 0)
				end = m_isctPoints[0];
			//			setArrowHeadSize(6,16);

			// create the arrow head shape
			AffineTransform at = getArrowTrans(start, end, m_curWidth);
			m_curArrow = at.createTransformedShape(m_arrowHead);

			// update the endpoints for the edge shape
			// need to bias this by arrow head size
			Point2D lineEnd = m_tmpPoints[1];
			lineEnd.setLocation(0, -m_arrowHeight);
			at.transform(lineEnd, lineEnd);
		} else {
			m_curArrow = null;
		}

		float[] pts = new float[(2 + bends.size()) * 2];
		pts[0] = (float) n1x;
		pts[1] = (float) n1y;
		pts[pts.length - 2] = (float) n2x;
		pts[pts.length - 1] = (float) n2y;

		int index = 2;
		for (Point2D point : bends) {
			pts[index] = (float) point.getX();
			pts[index + 1] = (float) point.getY();
			index += 2;
		}

		return GraphicsLib.cardinalSpline(pts, 0.05f, false);
		//return null;
	}

	//	@Override
	//	protected Shape getRawShape(VisualItem item) {
	//		@SuppressWarnings("unchecked")
	//		LinkedList<Point2D> bends = (LinkedList<Point2D>) (item.get(PNConstants.EDGE_BENDS_KEY) != null ? new LinkedList<>(
	//				(List<Point2D>) item.get(PNConstants.EDGE_BENDS_KEY)) : new LinkedList<>());
	//		//		LinkedList<Point2D> bends = new LinkedList<>((List<Point2D>) item.get(PNConstants.EDGE_BENDS_KEY));
	//		EdgeItem edge = (EdgeItem) item;
	//		VisualItem sourceItem = edge.getSourceItem();
	//		VisualItem targetItem = edge.getTargetItem();
	//
	//		// Operations for the arrow
	//		m_tmpPoints[0].setLocation(bends.get(bends.size() - 2));
	//		m_tmpPoints[1].setLocation(bends.get(bends.size() - 1));
	//
	//		m_curWidth = (float) (m_width * getLineWidth(item));
	//
	//		// create the arrow head, if needed
	//		EdgeItem e = (EdgeItem) item;
	//
	//		// get starting and ending edge endpoints
	//		//            boolean forward = (m_edgeArrow == Constants.EDGE_ARROW_FORWARD);
	//		Point2D start = null, end = null;
	//		start = m_tmpPoints[0];
	//		end = m_tmpPoints[1];
	//
	//		// compute the intersection with the target bounding box
	//		int i = GraphicsLib.intersectLineRectangle(start, end, targetItem.getBounds(), m_isctPoints);
	//		if (i > 0)
	//			end = m_isctPoints[0];
	//
	//		// create the arrow head shape
	//		AffineTransform at = getArrowTrans(start, end, m_curWidth);
	//		m_curArrow = at.createTransformedShape(m_arrowHead);
	//
	//		
	//		
	//		// update the endpoints for the edge shape
	//		// need to bias this by arrow head size
	//		Point2D lineEnd = m_tmpPoints[1];
	//		lineEnd.setLocation(0, -m_arrowHeight);
	//		at.transform(lineEnd, lineEnd);
	//
	//		// Construction of path
	//		path.reset();
	//		Point2D point;
	//
	//		if (GraphicsLib.intersectLineRectangle(bends.get(0), bends.get(1), sourceItem.getBounds(), m_isctPoints) > 0)
	//			point = m_isctPoints[0];
	//		else
	//			point = bends.get(0);
	//
	//		path.moveTo(point.getX(), point.getY());
	//
	//		for (int j = 1; j < bends.size() - 2; j++) {
	//			point = bends.get(j);
	//			path.lineTo(point.getX(), point.getY());
	//		}
	//
	//		point = m_tmpPoints[0];
	//		path.lineTo(point.getX(), point.getY());
	//
	//		point = m_tmpPoints[1];
	//		path.lineTo(point.getX(), point.getY());
	//
	//		return path;
	//	}

	public static int intersectLineDiamond(Point2D a1, Point2D a2, Rectangle2D r, Point2D[] pts) {
		double a1x = a1.getX(), a1y = a1.getY();
		double a2x = a2.getX(), a2y = a2.getY();
		double mxx = r.getMaxX(), mxy = r.getMaxY();
		double mnx = r.getMinX(), mny = r.getMinY();
		double mhx = mnx + (mxx - mnx) * 0.5, mhy = mny + (mxy - mny) * 0.5;

		if (pts[0] == null)
			pts[0] = new Point2D.Double();
		if (pts[1] == null)
			pts[1] = new Point2D.Double();

		int i = 0;
		if (GraphicsLib.intersectLineLine(mhx, mny, mxx, mhy, a1x, a1y, a2x, a2y, pts[i]) > 0)
			i++;
		if (GraphicsLib.intersectLineLine(mxx, mhy, mhx, mxy, a1x, a1y, a2x, a2y, pts[i]) > 0)
			i++;
		if (i == 2)
			return i;
		if (GraphicsLib.intersectLineLine(mhx, mxy, mnx, mhy, a1x, a1y, a2x, a2y, pts[i]) > 0)
			i++;
		if (i == 2)
			return i;
		if (GraphicsLib.intersectLineLine(mnx, mhy, mhx, mny, a1x, a1y, a2x, a2y, pts[i]) > 0)
			i++;
		return i;
	}

}
