package org.processmining.humbertogarciacaballero.models.model;

import java.awt.Color;

import prefuse.data.expression.AndPredicate;
import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.ColorLib;

public class PNConstants {

    // Data keys
    public static final String NODE_ID_KEY                      = "originalId";                      // String
	public static final String NODE_TYPE_KEY		 			= "type";                            // String
	public static final String NODE_LABEL_KEY		 			= "label";                           // String                          
	public static final String NODE_WIDTH_KEY                   = "width";                           // Integer
	public static final String NODE_HEIGHT_KEY                  = "height";                          // Integer
	public static final String NODE_LAYER_KEY					= "layer";                           // Integer
	public static final String NODE_SEQUENCE_KEY                = "sequence";                        // Integer
	public static final String NODE_MAX_LAYER_KEY				= "maxlayer";                        // Integer
	public static final String NODE_DEPTH_KEY                   = "nodedepth";                       // Integer
	public static final String NODE_TAU_TRANSITION_KEY          = "tautransition";                   // Boolean
	public static final String NODE_PARALLEL_NODES_KEY          = "parallelnodes";                   // List<Node>
	public static final String NODE_CHOICE_NODES_KEY            = "choicenodes";                     // List<Node>
	public static final String NODE_STARTING_KEY                = "startingnode";                    // Boolean
	public static final String NODE_ENDING_KEY                  = "endingnode";                      // Boolean
	public static final String NODE_TOKEN_COUNT_KEY             = "tokencount";                      // Integer
	public static final String NODE_NON_LIVE_TRANSITION_KEY     = "nonlivetransition";               // Boolean
	public static final String NODE_DEAD_TRANSITION_KEY         = "deadtransition";                  // Boolean
	public static final String NODE_UNBOUNDED_PLACE_KEY         = "unboundedplace";                  // Boolean
	public static final String NODE_SELECTED_TRANSITION			= "selectedtransition";	 			 // Boolean				 
	public static final String FILLING_EXTRA_COLOR_KEY          = "fillingcolors";                   // Color[]
    public static final String SIMPLIFIED_KEY                   = "simplified";                      // Boolean
    public static final String SIMPLIFIED_OLD_KEY               = "simplifiedold";                   // Boolean
    public static final String SIMPLIFIED_TOP_KEY               = "simplified_top";                  // Boolean
    public static final String SIMPLIFIED_BOTTOM_KEY            = "simplified_bottom";               // Boolean
	public static final String EDGE_BENDS_KEY		 			= "bends";                           // List<Poin2D>
	public static final String EDGE_COLOR_KEY		 			= "color";	                         // Integer
    public static final String EDGE_SIMPLIFICABLE               = "edgesimplificable";               // Boolean
    public static final String EDGE_FORCE_SIMPLIFICATION        = "forcesimplification";             // Boolean
    public static final String EDGE_SOURCE_PORT_OFFSET          = "edgesourceportoffset";            // Float
    public static final String EDGE_TARGET_PORT_OFFSET          = "edgetargetportoffset";            // Float
    public static final String EDGE_BIDIRECTIONAL               = "bidirectional";                   // Boolean
    public static final String EDGE_BIDIRECTIONAL_DRAW			= "bidirectionaldraw";				 // Boolean
    public static final String EDGE_RESET_KEY                   = "resetarc";                        // Boolean
    public static final String EDGE_INHIBITOR_KEY               = "inhibitorarc";                    // Boolean
    public static final String EDGE_LONG_EDGE_KEY               = "longedge";                        // Boolean
    public static final String LOOP_KEY                         = "looppart";                        // Integer
    public static final String VISIBLE_IN_DEGREE                = "visibleindegree";                 // Integer
    public static final String VISIBLE_OUT_DEGREE               = "visibleoutdegree";                // Integer
    public static final String EMPTY_LABEL                      = "";
	
	// Visual properties
    public static final int    EDGE_DEFAULT_COLOR	 			           = ColorLib.color(Color.BLACK);
	public static final int    EDGE_HIGHLIGHT_COLOR                        = ColorLib.darker(ColorLib.gray(100));
	public static final float  STROKE_DEFAULT_WIDTH 			           = 0.8f;
	public static final int	   HIGHLIGHTED_NODE_COLOR			           = ColorLib.rgb(144, 195, 212);
	public static final int    INCOMING_HIGHLIGHTED_NODE_COLOR	           = ColorLib.rgb(242, 124, 124);
	public static final int    OUTGOING_HIGHLIGHTED_NODE_COLOR	           = ColorLib.rgb(0, 230, 118);
    public static final int    INCOMING_HIGHLIGHTED_EDGE_COLOR             = ColorLib.darker(INCOMING_HIGHLIGHTED_NODE_COLOR);
    public static final int    OUTGOING_HIGHLIGHTED_EDGE_COLOR             = ColorLib.darker(OUTGOING_HIGHLIGHTED_NODE_COLOR);
	public static final int    INCOUTGOING_HIGHLIGHTED_NODE_COLOR          = ColorLib.rgb(0, 50, 118);
	public static final int    STROKE_COLOR 					           = ColorLib.color(Color.BLACK);
	public static final int    FONT_COLOR						           = ColorLib.rgb(0,0,0);
	public static final int    FONT_COLOR_OPPOSITE                         = ColorLib.rgb(255,255,255);
	public static final int    BAR_TEXT_OFFSET                             = 10;
	public static final int    TAU_TRANSITIONS_BG_COLOR                    = ColorLib.rgb(135, 135, 135);
	public static final int    TAU_TRANSITIONS_SIZE                        = 3;
	public static final int    SHAPE_TRANSITION                            = 10;
	public static final String SIMPLIFIER_DECORATOR_WIDTH                  = "width";
	public static final String SIMPLIFIER_DECORATOR_HEIGHT                 = "height";
	public static final float  LONG_EDGES_TEXT_OFFSET                      = 2.5f;
	public static final int TEMP_NODES_EDGES_COLOR = ColorLib.rgb(144, 195, 212);
	
	// Visualization actions
	public static final String VIS_DECORATORS_ACTIONS_NAME                 = "decorators";
	public static final String VIS_SHAPE_ASSIGNMENT_ACTIONS_NAME 		   = "aspect";
	public static final String VIS_LAYOUT_ACTIONS_NAME 			           = "layout";
	public static final String VIS_LAYOUT_NO_PAINT_ACTIONS_NAME            = "layoutnopaint";
	public static final String VIS_ANIMATE_LAYOUT_ACTIONS_NAME             = "animatelayout";
	public static final String VIS_LAYOUT_FIT_BOUNDS_ACTIONS_NAME          = "fitbounds";
	public static final String VIS_LAYOUT_FIT_BOUNDS_ANIMATED_ACTIONS_NAME = "fitboundsanimated";
	public static final String VIS_LAYOUT_DECORATORS			           = "layoutdecorators";
	public static final String VIS_LAYOUT_ROTATE 				           = "layoutrotate";
	public static final String VIS_HIGHLIGHT_ACTIONS_NAME 		           = "highlights";
	public static final String VIS_HIGHLIGHT_EDGES_ACTIONS_NAME            = "highlightsedges";
	public static final String VIS_LOOP_MODE_ANIMATIONS_ACTIONS_NAME       = "loopmodeanimations";
	public static final String VIS_SIMPLIFIER_DECORATOR_ACTIONS            = "simplifierdecoratoraction";
	public static final String VIS_REPAINT_ACTIONS_NAME                    = "repaint";
    public static final String VIS_FILL_NODES_ACTIONS_NAME                 = "fillnodes";
    public static final String VIS_FILL_NODES_DEPTH_ACTIONS_NAME           = "fillnodesdepth";
    public static final String VIS_FILL_EDGES_ACTIONS_NAME                 = "filledges";
    public static final String VIS_STROKE_EDGES_ACTIONS_NAME               = "strokeedges";
    public static final String VIS_POSITION_ANIMATE_ACTIONS_NAME           = "positionanimate";
    public static final String VIS_TEXT_COLOR_ACTIONS_NAME                 = "textcoloraction";
    public static final String VIS_SOUNDNESS_COLOR_ACTIONS_NAME            = "soundnesscoloraction";
    public static final String VIS_SOUNDNESS_PROBLEMATIC_FIT_ACTIONS_NAME  = "problematicgroupfitaction";
    public static final String VIS_STROKE_COLOR_ACTIONS_NAME			   = "strokecoloraction";	
    
    // Other properties
    public static final int    TRANSITIONS_DEFAULT_WIDTH                   = 10;
    public static final int    PLACES_DEFAULT_SIZE                         = 20;
    public static final int    TRANSITIONS_DEFAULT_HEIGHT                  = 20;
    public static final int    FONT_DEFAULT_SIZE                           = 12;
    public static final int    FONT_DEGREE_DEFAULT_SIZE                    = 2;
    public static final long   ANIMATION_LENGTH_DEFAULT                    = 1500;
    public static final float  STARTING_NODE_SHAPE_PERCENTAGE_SIZE         = 0.2f;
    public static final float  ENDING_NODE_SHAPE_PERCENTAGE_SIZE           = 0.8f;
    public static final int    INTRACELL_SPACING_DEFAULT                   = 5;
    public static final int    LAYER_SPACING_DEFAULT                       = 15;
    public static final int    EDGE_LANDING_OFFSET_DEFAULT                 = 2;
    
    // Predicates
    public static final Predicate STARTING_NODE_PREDICATE                  = ExpressionParser.predicate("[" + NODE_STARTING_KEY + "] = TRUE OR [" + NODE_TOKEN_COUNT_KEY + "] > 0");
    public static final Predicate ENDING_NODE_PREDICATE                    = ExpressionParser.predicate("[" + NODE_ENDING_KEY + "] = TRUE");
    public static final Predicate TRANSITION_NODE_PREDICATE                = ExpressionParser.predicate("[" + PNConstants.NODE_TYPE_KEY + "] = \"" + NodeType.TRANSITION + "\"");
    public static final Predicate TAU_TRANSITIONS_PREDICATE                = new AndPredicate(TRANSITION_NODE_PREDICATE, ExpressionParser.predicate("[" + NODE_TAU_TRANSITION_KEY + "] = TRUE"));
    public static final Predicate LOOP_PREDICATE                           = ExpressionParser.predicate("[" + PNConstants.LOOP_KEY + "] >= 0");
    public static final Predicate FORCE_SIMPLIFICATION_PREDICATE           = ExpressionParser.predicate("[" + EDGE_FORCE_SIMPLIFICATION + "] = TRUE");
    
    
    public static final int CONFORMANCE_ACTIVITY_NODE_COLOR = ColorLib.rgb(218,83,44);		//PMD conformance
    public static final int    INPUT_OUTPUT_HIGHLIGHTED_NODE_COLOR		= ColorLib.gray(100);
    public static final boolean DEBUG                                      = true;
}
