package org.processmining.humbertogarciacaballero.models.model.commands;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Visualization;
import prefuse.visual.NodeItem;

public class AddToMarkingCommand extends AbstractCommand {

    private Visualization vis;
    private NodeItem node;
    
    public AddToMarkingCommand(Visualization vis, NodeItem node) {
        this.vis = vis;
        this.node = node;
    }
    
    @Override
    public void doIt() {
        node.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, node.getInt(PNConstants.NODE_TOKEN_COUNT_KEY) + 1);
        runActions();
    }

    @Override
    public void undoIt() {
        node.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, node.getInt(PNConstants.NODE_TOKEN_COUNT_KEY) - 1);
        runActions();
    }

    private void runActions() {
        vis.run(PNConstants.VIS_DECORATORS_ACTIONS_NAME);
        vis.run(PNConstants.VIS_TEXT_COLOR_ACTIONS_NAME);
        vis.run(PNConstants.VIS_REPAINT_ACTIONS_NAME);
        finish();
    }
    
}
