package org.processmining.humbertogarciacaballero.models.model.commands;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Visualization;
import prefuse.visual.VisualItem;

public class RemoveFromMarkingCommand extends AbstractCommand {

    private Visualization vis;
    private VisualItem item;
    private boolean removeAll;
    private int oldValue;
    
    public RemoveFromMarkingCommand(Visualization vis, VisualItem item, boolean removeAll) {
        this.vis = vis;
        this.item = item;
        this.removeAll = removeAll;
    }
    
    @Override
    public void doIt() {
        if (removeAll) {
            oldValue = item.getInt(PNConstants.NODE_TOKEN_COUNT_KEY);
            item.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, 0);
        } else {
            item.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, Math.max(item.getInt(PNConstants.NODE_TOKEN_COUNT_KEY) - 1, 0));
        }
        runActions();
    }

    @Override
    public void undoIt() {
        if (removeAll) {
            item.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, oldValue);
        } else {
            item.setInt(PNConstants.NODE_TOKEN_COUNT_KEY, item.getInt(PNConstants.NODE_TOKEN_COUNT_KEY) + 1);
        }
    }

    private void runActions() {
        vis.run(PNConstants.VIS_DECORATORS_ACTIONS_NAME);
        vis.run(PNConstants.VIS_TEXT_COLOR_ACTIONS_NAME);
        vis.run(PNConstants.VIS_REPAINT_ACTIONS_NAME);
        finish();
    }
    
}
