package org.processmining.humbertogarciacaballero.models.model.layout.data;

public enum LayoutOrientation {
	TOP_TO_BOTTOM("Top to bottom ↓"), RIGHT_TO_LEFT("Right to left ←"), BOTTOM_TO_TOP("Bottom to top ↑"), LEFT_TO_RIGHT("Left to right →"), ;
	
	private String label;
	
	private LayoutOrientation(String label) {
		this.label = label;
	}
	
	public LayoutOrientation clockwise() {
		int length = values().length;
		
		return values()[(ordinal() + 1) % length]; 
	}
	
	public LayoutOrientation antiClockwise() {
		int length = values().length;
		
		if (ordinal() == 0) {
			return values()[length - 1];
		}
		
		return values()[ordinal() - 1]; 
	}	
	
	public LayoutOrientation opposite() {
		switch (this) {
		case TOP_TO_BOTTOM:
			return BOTTOM_TO_TOP;
		case BOTTOM_TO_TOP:
			return TOP_TO_BOTTOM;
		case LEFT_TO_RIGHT:
			return RIGHT_TO_LEFT;
		default:
			return LEFT_TO_RIGHT;
		}
	}
	
	public String toString() {
		return label;
	}
}
