package org.processmining.humbertogarciacaballero.models.model.layout.stage.layerer;

public enum LayeringStrategy {
	
	BFS_DIRECTED("BFS directed", BFSDirectedLayerer.class),
	BFS_UNDERICTED("BFS undirected", BFSUnderictedLayerer.class),
	DFS_DIRECTED("DFS directed", DFSDirectedLayerer.class),
	DFS_UNDERICTED("DFS undirected", DFSUndirectedLayerer.class),
	LONGEST_PATH("Longest path", LongestPathLayerer.class),
	CONSECUTIVE_LAYERER("Consecutive layerer", ConsecutiveLayerer.class),
	SIMPLEX_LAYERER("Simplex layerer", SimplexLayerer.class);
//	COFFMAN_GRAHAM("Coffman-Graham", CoffmanGrahamLayerer.class);

	private Class<? extends Layerer> algorithm;
	private String label;

	private LayeringStrategy(String title, Class<? extends Layerer> algorithm) {
		this.algorithm = algorithm;
		this.label = title;
	}

	public Class<? extends Layerer> getAlgorithm() {
		return algorithm;
	}

	@Override
	public String toString() {
		return label;
	}
}
