package org.processmining.humbertogarciacaballero.models.model.layout.stage.lines;

import java.awt.geom.Point2D;
import java.util.List;

import org.processmining.humbertogarciacaballero.models.model.layout.HierarchicalLayouter;
import org.processmining.humbertogarciacaballero.models.model.layout.HierarchicalLayouter.EdgeParams;
import org.processmining.humbertogarciacaballero.models.model.layout.stage.HierarchicalLayoutContext;

import prefuse.data.Edge;
import prefuse.data.Node;

public class StraightLineBendCalculator extends BendCalculator {

    public StraightLineBendCalculator(HierarchicalLayoutContext context) {
        super(context);
    }

    @Override
    public void createBends(Edge e, int layerDifference, List<Node> dummies) {
        EdgeParams params = ((EdgeParams) e.get(HierarchicalLayouter.EDGE_PARAMS));

        List<Point2D> bends = params.bends;

        if (dummies != null) {
            for (Node dummy : dummies) {
                bends.add(new Point2D.Double(getX(dummy), getY(dummy)));
            }
        }
    }

}
