package org.processmining.humbertogarciacaballero.plugins;

import java.util.HashSet;
import java.util.Set;

import javax.swing.JComponent;

import nl.tue.astar.AStarException;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.plugins.petrinet.replayer.PNLogReplayer;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsVizViews;
import org.processmining.prabhakardixit.processanalytics.models.ChartView;
import org.processmining.prabhakardixit.processanalytics.models.GraphData;
import org.processmining.prabhakardixit.processanalytics.models.ProcessView;
import org.processmining.prabhakardixit.processanalytics.models.TimeView;


@Plugin(name = "Petri net generato124r", parameterLabels = {
		"Log " , "Petri net"}, returnLabels = { "Name of your output" }, returnTypes = { ProcessAnalyticsVizViews.class })
public class ConformancePlugin  extends InteractiveVisualizer {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log 
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public JComponent yourPrivatePlugin(PluginContext context, XLog log, Petrinet pn)
			throws IllegalAccessException, InstantiationException {
		//AcceptingPetriNetArray apn =  tempRun.temprun(pn);
		//PetriNetMap pnMap = new PetriNetMap(pn);
		//List<PetriNetMap> pnMapList=  tempRun.temprun(pnMap);
		//List<PetriNetMap> pnMapList=  org.processmining.prabhakardixit.fcnets.synthesis.SynthesisTempRun.temprun(pnMap);
		//VisualizeAcceptingPetriNetArrayPlugin a = new VisualizeAcceptingPetriNetArrayPlugin();
		//a.visualize(context, apn);
		//InteractivePetriNet ipn = new InteractivePetriNet(pnMapList, "");
		//ipn.setAcceptingPetriNetArray(apn);
		//CalculateLogHeuristics.calculateRelations(log);
		return null; 
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 * @throws AStarException 
	 * @throws ConnectionCannotBeObtained 
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0, 1})
	public ProcessAnalyticsVizViews visualize(UIPluginContext context, XLog log, Petrinet pn) throws IllegalAccessException,
			InstantiationException, ConnectionCannotBeObtained, AStarException {
		PNLogReplayer replayer = new PNLogReplayer();
		PNRepResult replayResult = replayer.replayLog(context,pn,log);
		ProcessAnalyticsVizViews pa = new ProcessAnalyticsVizViews(replayResult, pn, log, TimeView.HOURS, ProcessView.CaseStart, ChartView.HISTOGRAM, GraphData.SyncMovesOnly);
		return pa;
//			return null;
			
		
	}
}


//@Plugin(name = "Process Analyt1cs", returnLabels = { "Visualized laidout Petri net" }, returnTypes = {
//		Petrinet.class }, parameterLabels = { "Petrinet, log" }, userAccessible = true, help = Help.PLUGIN_ACCEPTING_NET_HELP_TEXT)
//@Visualizer
//public class ConformancePlugin extends InteractiveVisualizer {
//
//	@PluginVariant(requiredParameterLabels = { 0, 1 })
//	public JComponent visualizeConformance(PluginContext context, Petrinet n, XLog log) {
//		
//	}
//	
//	@UITopiaVariant(affiliation = "TU/e", author = "The kiddos", email = "")
//	@PluginVariant(variantLabel = "Process Analyt1cs", requiredParameterLabels = { 0})
//	public Petrinet visualize(UIPluginContext context, Petrinet n, XLog log) throws IllegalAccessException,
//			InstantiationException {
//		
//			return null;
//			
//		
//	}
	
//}
