package org.processmining.humbertogarciacaballero.plugins;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.humbertogarciacaballero.help.Help;
import org.processmining.models.graphbased.directed.petrinet.InhibitorNet;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.ResetInhibitorNet;
import org.processmining.models.graphbased.directed.petrinet.ResetNet;
import org.processmining.models.semantics.petrinet.Marking;

@Plugin(name = "Interactive Petri Net Visualizer Conformance", returnLabels = { "Visualized laidout Petri net" }, returnTypes = {
		JComponent.class }, parameterLabels = { "Petri net",
				"Initial Marking" }, userAccessible = true, help = Help.PLUGIN_HELP_TEXT)
@Visualizer
public class InteractivePetrinetVisualizer extends InteractiveVisualizer {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, Petrinet n) {
		return visualizeWithAll(context, n, null);
	}

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, ResetNet n) {
		return visualizeWithAll(context, n, null);
	}

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, InhibitorNet n) {
		return visualizeWithAll(context, n, null);
	}

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, ResetInhibitorNet n) {
		return visualizeWithAll(context, n, null);
	}

	@PluginVariant(requiredParameterLabels = { 0, 1 })
	public JComponent visualize(PluginContext context, Petrinet n, Marking m) {
		return visualizeWithAll(context, n, m);
	}

	@PluginVariant(requiredParameterLabels = { 0, 1 })
	public JComponent visualize(PluginContext context, ResetNet n, Marking m) {
		return visualizeWithAll(context, n, m);
	}

	@PluginVariant(requiredParameterLabels = { 0, 1 })
	public JComponent visualize(PluginContext context, InhibitorNet n, Marking m) {
		return visualizeWithAll(context, n, m);
	}

	@PluginVariant(requiredParameterLabels = { 0, 1 })
	public JComponent visualize(PluginContext context, ResetInhibitorNet n, Marking m) {
		return visualizeWithAll(context, n, m);
	}
}
