package org.processmining.prabhakardixit.CalculateLogHeuristics;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.deckfour.xes.info.XLogInfo;
import org.deckfour.xes.info.XLogInfoFactory;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.incrementaldiscovery.PolicyBasedOnOrdering;
import org.processmining.prabhakardixit.alignments.TransPairAlignment;

public class CalculateLogHeuristics {
	//	public static Map<String, Map<String, Double>> followsMap;
	//	public static Map<String, Map<String, Double>> precedesMap;
	//	public static Map<String, Map<String, Double>> coOccursMap; //initiate all
	//	public static Map<String, Double> occursCount = new HashMap<String, Double>();
	public XLogInfo info;
	public Set<String> events;
	
	//this is info for the currently selected event
	private Map<String, Integer> eventuallyFollows = new HashMap<String, Integer>();
	private Map<String, Integer> eventuallyPrecedes = new HashMap<String, Integer>();
	private Map<String, Integer> directlyFollows = new HashMap<String, Integer>();
	private Map<String, Integer> directlyPrecedes = new HashMap<String, Integer>();
	private int maxOcc = 0;		//max repeatations
	private int minOcc = 0;		//min number of times 
	private float casePerct = 0.f;		//percentage of cases in which act happens
	private float avgOcc = 0.f;		//number of average occurrences per case
	
	//	public static Map<String, Map<String, Double>> directlyFollowsMap;
	//	public static Map<String, Map<String, Double>> directlyPrecedesMap;
	//	public static Map<String, Map<String, Double>> eventuallyFollowsMap;
	//	public static Map<String, Map<String, Double>> eventuallyPrecedesMap;
	//	public static Map<String, Double> avgOccurrences;
	//	public static Map<String, Integer> numOfOccurrences;
	//	public static Map<String, Integer> logSeqInput;
	//	public static Map<String, Set<String>> attrValMap = new HashMap<String, Set<String>>();

	//alignment specific info
	//	public static Multiset<String> misalignedActs;
	//	public static Multiset<Transition> misalignedTrans;
	//	public static List<AggregatedTraceLevelPairwiseInfo> traceLevelInfo;

	//	public static Map<Transition, Double> syncMoveCost;
	//	public static Map<String, Double> logMoveCost;
	//	public static Map<Transition, Double> modelMoveCost;
	//	public static Map<String, XLog> actLog;

	public Set<TransPairAlignment> tranPairs;
	
	public List<String> orderedBasedOnSeq;

	public CalculateLogHeuristics(XLog log) {
		events = new HashSet<String>();

		//alignment
		tranPairs = new HashSet<TransPairAlignment>();
		initiateInfo(log);
		Set<TransPairAlignment> tranPairs = new HashSet<TransPairAlignment>();
		this.tranPairs.addAll(tranPairs);
		for (XTrace trace : log) {
			for (XEvent event : trace) {
				//				eventSequence.add(XConceptExtension.instance().extractName(event));
				//				currEvtStr = XConceptExtension.instance().extractName(event);

			}

		}
		
		PolicyBasedOnOrdering pbo = new PolicyBasedOnOrdering(events, log);
		orderedBasedOnSeq = pbo.getPolicyBasedOnOrdering();

	}

	private void initiateInfo(XLog log) {
		final XEventNameClassifier lifecycleClassifier = new XEventNameClassifier();
		info = XLogInfoFactory.createLogInfo(log, lifecycleClassifier);
		for (XEventClass event : info.getEventClasses().getClasses()) {
			events.add(event.toString());
			//			events.add(event.toString().replace("+complete", ""));
			System.out.println(event.getId());
		}
	}

	public <K, V extends Comparable<? super V>> Map<K, V> entriesSortedByValues(Map<K, V> map) {

		List<Map.Entry<K, V>> list = new LinkedList<>(map.entrySet());
		Collections.sort(list, new Comparator<Map.Entry<K, V>>() {
			@Override
			public int compare(Map.Entry<K, V> e1, Map.Entry<K, V> e2) {
				return (e2.getValue()).compareTo(e1.getValue());
			}
		});

		Map<K, V> result = new LinkedHashMap<>();
		for (Map.Entry<K, V> entry : list) {
			result.put(entry.getKey(), entry.getValue());
		}

		return result;

	}

	public Set<String> getActivities() {
		return events;
	}

	public Map<String, Integer> getDirectlyFollows() {
		return directlyFollows;
	}

	public void setDirectlyFollows(String act, int val) {
		directlyFollows.put(act, val);
	}

	public void setDirectlyPrecedes(String act, int val) {
		directlyPrecedes.put(act, val);
	}

	public void setDirectlyFollows(Map<String, Integer> directlyFollows) {
		this.directlyFollows = directlyFollows;
	}

	public Map<String, Integer> getDirectlyPrecedes() {
		return directlyPrecedes;
	}

	public void setDirectlyPrecedes(Map<String, Integer> directlyPrecedes) {
		this.directlyPrecedes = directlyPrecedes;
	}
	
	
//
	public Map<String, Integer> getEventuallyFollows() {
		return eventuallyFollows;
	}

	public void setEventuallyFollows(String act, int val) {
		eventuallyFollows.put(act, val);
	}

	public void setEventuallyPrecedes(String act, int val) {
		eventuallyPrecedes.put(act, val);
	}

	public int getMaxOcc() {
		return maxOcc;
	}

	public void setMaxOcc(int maxOcc) {
		this.maxOcc = maxOcc;
	}

	public int getMinOcc() {
		return minOcc;
	}

	public void setMinOcc(int minOcc) {
		this.minOcc = minOcc;
	}

	public float getCasePerct() {
		return casePerct;
	}

	public void setCasePerct(float casePerct) {
		this.casePerct = casePerct;
	}

	public void setEventuallyFollows(Map<String, Integer> eventuallyFollows) {
		this.eventuallyFollows = eventuallyFollows;
	}

	public Map<String, Integer> getEventuallyPrecedes() {
		return eventuallyPrecedes;
	}

	public void setEventuallyPrecedes(Map<String, Integer> eventuallyPrecedes) {
		this.eventuallyPrecedes = eventuallyPrecedes;
	}
	
	public List<String> getOrderedBasedOnSeq() {
		return orderedBasedOnSeq;
	}

	public void setOrderedBasedOnSeq(List<String> orderedBasedOnSeq) {
		this.orderedBasedOnSeq = orderedBasedOnSeq;
	}

	public float getAvgOcc() {
		return avgOcc;
	}

	public void setAvgOcc(float avgOcc) {
		this.avgOcc = avgOcc;
	}
	
	
	
}
