package org.processmining.prabhakardixit.alignments;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.deckfour.xes.model.XEvent;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

import com.google.common.collect.HashMultiset;
import com.google.common.collect.Multiset;

public class AggregatedTraceLevelPairwiseInfo {

	Set<Integer> ids = new HashSet<Integer>();
	List<XEvent> eventSeq = new ArrayList<XEvent>();
	int numTraces;
	Multiset<Transition> syncMoves = HashMultiset.create();
	Multiset<Transition> modelMoves = HashMultiset.create();
	Multiset<String> logMoves = HashMultiset.create();

	public AggregatedTraceLevelPairwiseInfo(List<String> eventSequence) {
		this.setEventSeq(eventSeq);
		this.numTraces = 1;
	}

	public List<XEvent> getEventSeq() {
		return eventSeq;
	}

	public void setEventSeq(List<XEvent> eventSeq) {
		this.eventSeq = eventSeq;
	}

	public int getNumTraces() {
		return getId().size();
	}

	public void setNumTraces(int numTraces) {
		this.numTraces = numTraces;
	}

	public Multiset<Transition> getSyncMoves() {
		return syncMoves;
	}

	public void setSyncMoves(Multiset<Transition> syncMoves) {
		this.syncMoves = syncMoves;
	}

	public Multiset<Transition> getModelMoves() {
		return modelMoves;
	}

	public void setModelMoves(Multiset<Transition> modelMoves) {
		this.modelMoves = modelMoves;
	}

	public Set<Integer> getId() {
		return ids;
	}

	public void setId(Set<Integer> id) {
		this.ids = id;
	}

	public Multiset<String> getLogMoves() {
		return logMoves;
	}

	public void setLogMoves(Multiset<String> logMoves) {
		this.logMoves = logMoves;
	}

	public void setLogMoves(String logMove) {
		this.logMoves.add(logMove);

	}
	
	public Integer getNumLogMoves(String act){
		return logMoves.count(act);
	}
	
	public Integer getNumSyncMoves(Transition t){
		return syncMoves.count(t);
	}
	public Integer getNumModelMoves(Transition t){
		return modelMoves.count(t);
	}

}
