package org.processmining.prabhakardixit.alignments;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;

public class ClusterNet {

	Map<Transition, Set<Transition>> tranCluster = new HashMap<Transition, Set<Transition>>();

	Petrinet net;
	Map<Transition, Transition> tranMap = new HashMap<Transition, Transition>(); //map of original transitions

	public ClusterNet(PetriNetMap pnmap) {
		this.net = pnmap.getPetriNet();
		this.tranMap = pnmap.getMapTransitions();
	}

	public Map<Transition, Set<Transition>> getTranCluster() {
		return tranCluster;
	}

	public void setTranCluster(Map<Transition, Set<Transition>> tranCluster) {
		this.tranCluster = tranCluster;
	}

	public Set<Transition> getTranCluster(Transition t) {
		if (!tranCluster.containsKey(t))
			tranCluster.put(t, new HashSet<Transition>());
		return tranCluster.get(t);
	}

	public void setTranCluster(Transition preTran, Set<Transition> tranCluster2) {
		if (!tranCluster.containsKey(preTran))
			tranCluster.put(preTran, tranCluster2);
		else
			tranCluster.get(preTran).addAll(tranCluster2);

	}

	public Petrinet getPetriNet() {
		// TODO Auto-generated method stub
		return this.net;
	}

	//get tran of original net from cnet
	public Transition getOriginalMappedTran(Transition t) {
		for (Transition tOrg : tranMap.keySet())
			if (tranMap.get(tOrg).equals(t))
				return tOrg;

		return null;

	}

	//get tran of cnet from original net
	public Transition getNewMappedTran(Transition tOrg) {
		return tranMap.get(tOrg);
	}
}
