package org.processmining.prabhakardixit.alignments;

import java.util.HashSet;
import java.util.Set;

public class CombinationUtils {

	static Set<Set<Integer>> allCombs = new HashSet<Set<Integer>>();

	/*
	 * arr[] ---> Input Array data[] ---> Temporary array to store current
	 * combination start & end ---> Staring and Ending indexes in arr[] index
	 * ---> Current index in data[] r ---> Size of a combination to be printed
	 */
	static void combinationUtil(int arr[], int data[], int start, int end, int index, int r) {
		// Current combination is ready to be printed, print it
		if (index == r) {
			Set<Integer> set1 = new HashSet<Integer>();
			for (int j = 0; j < r; j++) {
				set1.add(data[j]);
				//				System.out.print(data[j] + " ");
			}
			allCombs.add(set1);
			//			System.out.println("");
			return;
		}

		// replace index with all possible elements. The condition
		// "end-i+1 >= r-index" makes sure that including one element
		// at index will make a combination with remaining elements
		// at remaining positions
		for (int i = start; i <= end && end - i + 1 >= r - index; i++) {
			data[index] = arr[i];
			combinationUtil(arr, data, i + 1, end, index + 1, r);
		}
	}

	// The main function that prints all combinations of size r
	// in arr[] of size n. This function mainly uses combinationUtil()
	static void printCombination(int arr[], int n, int r) {
		// A temporary array to store all combination one by one
		int data[] = new int[r];

		// Print all combination using temprary array 'data[]'
		combinationUtil(arr, data, 0, n - 1, 0, r);
	}

	/* Driver function to check for above function */
	public static void main(String[] args) {
		int arr[] = { 1, 2, 3, 4, 5 };
		Set<Integer> set = new HashSet<Integer>();
		for (int i = 0; i < arr.length; i++)
			set.add(arr[i]);
		getAllCombs(set);

		for (Set<Integer> i : allCombs)
			System.out.println(i);
	}

	public static Set<Set<Integer>> getAllCombs(Set<Integer> set) {
		allCombs.clear();
		int arr[] = new int[set.size()];
		int c = 0;
		for (Integer i : set)
			arr[c++] = i;
		//        int r = 3;
		int n = arr.length;
		for (int r = 0; r < n; r++) {
			getCombination(arr, n, r);
		}

		return allCombs;
	}

	public static Set<Set<Integer>> getAllCombs(Set<Integer> set, int card) {
		allCombs.clear();
		int arr[] = new int[set.size()];
		int c = 0;
		for (Integer i : set)
			arr[c++] = i;
		int n = arr.length;
		getCombination(arr, n, card);

		return allCombs;
	}

	// The main function that prints all combinations of size r
	// in arr[] of size n. This function mainly uses combinationUtil()
	static void getCombination(int arr[], int n, int r) {
		// A temporary array to store all combination one by one
		int data[] = new int[r];

		// Print all combination using temprary array 'data[]'
		combinationUtil(arr, data, 0, n - 1, 0, r);
	}
}
