package org.processmining.prabhakardixit.alignments;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

@Plugin(name = "Petri net editor with alignment view", parameterLabels = { "Log " }, returnLabels = { "Name of your output" }, returnTypes = { Petrinet.class })
public class PluginExporePetriNet {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */

	public Petrinet net(UIPluginContext context, Petrinet log) throws IllegalAccessException, InstantiationException {
		context.getProvidedObjectManager().createProvidedObject(
				"Petri net Filtered ", log, Petrinet.class, context);
		context.getGlobalContext().getResourceManager().getResourceForInstance(log)
				.setFavorite(true);
		return log;
	}

}

