package org.processmining.prabhakardixit.alignments.visualization;

import javax.swing.JComponent;
import javax.swing.JPanel;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.widgets.ProMSplitPane;
import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.alignments.PluginExploreLog;
import org.processmining.prabhakardixit.alignments.PluginExporePetriNet;
import org.processmining.prabhakardixit.alignments.ProjectedAveragedAlignments;
import org.processmining.prabhakardixit.alignments.TransPairAlignment;

public class ModelLogView {
	public static JComponent getResults(PNetVisualizerController controller, TransPairAlignment tpa) {
		JPanel panel = new JPanel();

		XLog log = ProjectedAveragedAlignments.createMergedLog(controller.getIPN().getLog(), tpa.getActivities(),true);
		Petrinet pn = tpa.getPetriNetMap().getPetriNet();

		JPanel jsp1 = GraphView.getGraph(controller, tpa);

		JPanel jsp2 = LogView.getLogView(log);
		ProMSplitPane splitPane = new ProMSplitPane(ProMSplitPane.HORIZONTAL_SPLIT);

		//				JSplitPane(JSplitPane.HORIZONTAL_SPLIT, true, jsp1, jsp2);
		//		splitPane.setOneTouchExpandable(true);
		//		panel.add(splitPane);

		splitPane.setTopComponent(jsp1);
		splitPane.setBottomComponent(jsp2);

		try {
			new PluginExporePetriNet().net(controller.getIPN().getUIContext(), tpa.getPetriNetMap().getPetriNet());
			new PluginExploreLog().log(controller.getIPN().getUIContext(), log);
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		splitPane.revalidate();
		splitPane.repaint();
		return splitPane;
	}
}
