package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.alignments.UpdateProjectedAveragedAlignments;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtils;
import org.processmining.prabhakardixit.fcnets.models.InteractiveMatrixNet;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;

public class AddNewTranBwTranAndPlace {
	public static void addTranBwTransitionAndPlace(Set<Place> placeSet, Set<Transition> tranSet, String transitionName,String newPlaceStr,
			InteractivePetriNet ipn, int newPlaceID, int newTranID, boolean isSilent) {

		PetriNetMap pnmap = ipn.getselectedPetriNetMap();
		Transition tNew = pnmap.getPetriNet().addTransition(transitionName);
		if (isSilent)
			tNew.setInvisible(true);
		Place pNew = pnmap.getPetriNet().addPlace(newPlaceStr);
		ipn.setPlaceId(pNew, newPlaceID);
		ipn.setTranId(tNew, newTranID);

		for (Transition t : tranSet)
			pnmap.getPetriNet().addArc(t, pNew);
		pnmap.getPetriNet().addArc(pNew, tNew);
		//		Place pold = pnmap.getPetriNet().addPlace(transitionName);
		for (Place p : placeSet) {
			//			pold = p;
			pnmap.getPetriNet().addArc(tNew, p);
			for (Transition t : tranSet)
				for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e : pnmap.getPetriNet()
						.getOutEdges(t))
					if (e.getTarget().equals(p))
						pnmap.getPetriNet().removeEdge(e);
		}
		//		PlaceConformanceUtils.updateAllPostTransitions(ipn);
		//		RunNaivePlaceBasedConformance rn = new RunNaivePlaceBasedConformance(ipn);
		//place conformance updates ends
		//new code starts
		if (ipn.isKeepHistory())
			updateLDSets(placeSet, tranSet, ipn.getInteractiveMatNet(), pNew, tNew);
		//new code ends

		//Choice and Place follows relations
		Set<Place> prevPlaceSet = new HashSet<Place>();
		for (Transition t : tranSet)
			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e : pnmap.getPetriNet().getInEdges(t))
				prevPlaceSet.add((Place) e.getSource());

		Set<Place> nextPlaceSet = new HashSet<Place>();

		nextPlaceSet.addAll(placeSet);

		boolean useNextForStart = false;
		for (Transition t : tranSet)
			if (pnmap.getPetriNet().getOutEdges(t).size() > 1) { //if Transition is split, then use the next for start
				useNextForStart = true;
			}

		//		if (VizToPnetMapper.log)
		long msecs = System.currentTimeMillis();
		if (ipn.isCalculateAlignments())
			UpdateProjectedAveragedAlignments.addSeqAlignmentCal(ipn, tNew); //alignments
		msecs += -System.currentTimeMillis();
		
		//DQ is data quality related? then update activities
		if(ipn.isDataQuality()){
			ipn.getDqModel().updateRepairActivities();
		}
		
//		System.out.println("Time taken for Seq alignment : " + msecs);
//		System.out.println("Tran  ids : " + ipn.getAllTranId());
//		System.out.println("Place ids : " + ipn.getAllPlaceId());

	}

	public static void addTranBwTransitionAndPlace(Place pl, Transition tr, String tranString, String newPlaceStr, InteractivePetriNet ipn,
			int newPlaceID, int newTranID, boolean isSilent) {
		// TODO Auto-generated method stub
		Set<Place> plSet = new HashSet<Place>();
		Set<Transition> trSet = new HashSet<Transition>();
		plSet.add(pl);
		trSet.add(tr);
		addTranBwTransitionAndPlace(plSet, trSet, tranString,newPlaceStr, ipn, newPlaceID, newTranID, isSilent);
	}

	//	private static void updateIncidenceMatrix(Set<Place> placeSet, Set<Transition> tranSet, InteractivePetriNet ipn,
	//			Place pNew, Transition tNew) {
	//		SimpleMatrix incidenceMatrixInput = ipn.getIncidenceMatrixInput();
	//		SimpleMatrix incidenceMatrixOutput = ipn.getIncidenceMatrixOutput();
	//		SimpleMatrix emptyRowInput = new SimpleMatrix(1, incidenceMatrixInput.numCols());
	//		SimpleMatrix emptyColInput = new SimpleMatrix(incidenceMatrixInput.numRows(), 1);
	//		SimpleMatrix emptyRowOutput = new SimpleMatrix(1, incidenceMatrixInput.numCols());
	//		SimpleMatrix emptyColOutput = new SimpleMatrix(incidenceMatrixInput.numRows(), 1);
	//		//		MatrixUtils.printMatrix(incidenceMatrix);
	//		incidenceMatrixInput = incidenceMatrixInput.combine(incidenceMatrixInput.numRows(), 0, emptyRowInput); //increase incidence Matrix with new row/col
	//		incidenceMatrixInput = incidenceMatrixInput.combine(0, incidenceMatrixInput.numCols(), emptyColInput);
	//		incidenceMatrixOutput = incidenceMatrixOutput.combine(incidenceMatrixOutput.numRows(), 0, emptyRowOutput);
	//		incidenceMatrixOutput = incidenceMatrixOutput.combine(0, incidenceMatrixOutput.numCols(), emptyColOutput);
	//		Set<Integer> placeIDs = new HashSet<Integer>();
	//		Set<Integer> tranIDs = new HashSet<Integer>();
	//		int newRow = ipn.getPlaceId(pNew);
	//		int newCol = ipn.getTranId(tNew); //new T id
	//		for (Place p : placeSet)
	//			placeIDs.add(ipn.getPlaceId(p));
	//		for (Transition t : tranSet)
	//			tranIDs.add(ipn.getTranId(t));
	//		for (Integer row : placeIDs) {
	//			for (Integer col : tranIDs) {
	//				incidenceMatrixInput.set(row, col, 0); //set prev t->p to zero (from 1)
	//			}
	//			int col = ipn.getTranId(tNew);
	//			incidenceMatrixInput.set(row, col, 1); //set prev t->tNew to 1 
	//		}
	//
	//		for (Integer col : tranIDs) {
	//			incidenceMatrixInput.set(newRow, col, 1); //set new pNew->tOld to 1 
	//		}
	//		incidenceMatrixOutput.set(newRow, newCol, -1);
	//		//		MatrixUtils.printMatrix(ipn.getIncidenceMatrix());
	//		ipn.setInciMatrixInput(incidenceMatrixInput);
	//		ipn.setInciMatrixOutput(incidenceMatrixOutput);
	//		//		doTest(ipn, newCol, tranIDs);
	//		//update TranLD
	//		MatrixUtils.updatePlaceLD(ipn, tranIDs, newCol);
	//		MatrixUtils.updateTranLD(ipn, placeIDs, newRow);
	//
	//	}

	//	private static void doTest(InteractivePetriNet ipn, Integer newCol, Set<Integer> tranIDs) {
	//		double [][] A = new double[ipn.getIncidenceMatrix().numCols()][ipn.getIncidenceMatrix().numCols()];
	//		for(int i=0;i<ipn.getIncidenceMatrix().numCols();i++)
	//			for(int j=0;j<ipn.getIncidenceMatrix().numCols();j++){
	//				if(i==j || i==newCol && tranIDs.contains(j))
	//					A[i][j] = 1;
	//				else
	//					A[i][j] = 0;
	//			}
	//		SimpleMatrix Am = new SimpleMatrix(A);
	//		MatrixUtils.printMatrix(Am);
	//		MatrixUtils.printMatrix(ipn.getIncidenceMatrix());
	//		MatrixUtils.printMatrix(ipn.getIncidenceMatrix().mult(Am));
	//	
	//		
	//	}

	public static void updateLDSets(Set<Place> placeSet, Set<Transition> tranSet, InteractiveMatrixNet imn, Place pNew,
			Transition tNew) {
		Set<Integer> placeIDs = new HashSet<Integer>();
		Set<Integer> tranIDs = new HashSet<Integer>();
		int newRow = imn.getPlaceId(pNew);
		int newCol = imn.getTranId(tNew); //new T id
		for (Place p : placeSet)
			placeIDs.add(imn.getPlaceId(p));
		for (Transition t : tranSet)
			tranIDs.add(imn.getTranId(t));

		//update tranld map
//		updateMapLDTrans(imn, tranIDs, newCol);
		//update TranLD
		MatrixUtils.updatePlaceLD(imn, imn.getselectedPetriNetMap().getPetriNet(), tranIDs, newCol);
		MatrixUtils.updateTranLD(imn, imn.getselectedPetriNetMap().getPetriNet(), placeIDs, newRow);

	}
	
//	private static void updateMapLDTrans(InteractiveMatrixNet imn, Set<Integer> prevTrans, int tNew) {
//		for (Set<Integer> startSet : imn.getMapLDTrans().keySet()) {
//			if (startSet.containsAll(prevTrans) || startSet.equals(prevTrans))
//				imn.getMapLDTrans().get(startSet).add(tNew);
//			else if (imn.getMapLDTrans().get(startSet).containsAll(prevTrans)
//					|| imn.getMapLDTrans().get(startSet).equals(prevTrans))
//				imn.getMapLDTrans().get(startSet).add(tNew);
//		}
//	}
}
