package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.List;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.synthesis.VizToPnetMapper;
import org.processmining.reduction.ReductionTracker;

public class ExpandUsingTracker {

	public static void expanUsingTracker(List<ReductionTracker> redTrack, InteractivePetriNet ipn) {
		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
		//first rule is always abstraction 

		//		//first map the mid place to the place from the abstraction rule
		//		Place placeMid = null;
		//		for (Place p : pn.getPlaces())
		//			if (pn.getInEdges(p).size() > 0 && pn.getOutEdges(p).size() > 0)
		//				placeMid = p;

		//		for (Integer i : redTrack.get(redTrack.size() - 1).getAtt2())
		//			ipn.setPlaceId(placeMid, i);
		//		System.out.println(redTrack.get(redTrack.size() - 1).getAtt1() + "  "
		//				+ redTrack.get(redTrack.size() - 1).getAtt2() + "  " + redTrack.get(redTrack.size() - 1).getName()
		//				+ "  " + ipn + "  " + redTrack.get(redTrack.size() - 1).isSilent());
		//		VizToPnetMapper.addNewTransition(redTrack.get(redTrack.size() - 1).getAtt1(), redTrack.get(redTrack.size() - 1)
		//				.getAtt2(), redTrack.get(redTrack.size() - 1).getName(), ipn, false,redTrack.get(redTrack.size() - 1).getNewPlaceID(),redTrack.get(redTrack.size() - 1).getNewTranID(), redTrack.get(redTrack.size() - 1).isSilent());

		//		IncrementalLayoutCalculations ilc = new IncrementalLayoutCalculations(pn);
		for (int i = redTrack.size() - 1; i >= 0; i--) {
			ReductionTracker currRedTrack = redTrack.get(i);
			switch (currRedTrack.getMethodName()) {
				case ABSTRACTION :
					//					System.out.println(currRedTrack.getAtt1() + "  " + currRedTrack.getAtt2() + "  "
					//							+ currRedTrack.getName() + "  " + ipn + "  " + currRedTrack.isSilent());
					VizToPnetMapper.addNewTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
							currRedTrack.getTranName(), currRedTrack.getPlaceName(), ipn, false,
							currRedTrack.getNewPlaceID(), currRedTrack.getNewTranID(), currRedTrack.isSilent());
					//					ilc.useAbstractionRule(currRedTrack.getAtt1(), currRedTrack.getAtt2(), ipn,
					//							currRedTrack.getNewPlaceID(), currRedTrack.getNewTranID());
					break;
				case LDPLACE :
					VizToPnetMapper.addParallelPlace(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
							currRedTrack.getPlaceName(), ipn, currRedTrack.getNewPlaceID());
					//					ilc.useLDRule(ipn, currRedTrack.getAtt1(), currRedTrack.getAtt2(), currRedTrack.getNewPlaceID(),
					//							true);
					break;
				case LDTRAN :
					VizToPnetMapper.addChoiceTransition(currRedTrack.getAtt1(), currRedTrack.getAtt2(),
							currRedTrack.getTranName(), ipn, currRedTrack.getNewTranID(), currRedTrack.isSilent());
					//					ilc.useLDRule(ipn, currRedTrack.getAtt1(), currRedTrack.getAtt2(), currRedTrack.getNewTranID(),
					//							false);
					break;
				case RENAME :
					Transition t = ipn.getTranBasedOnID(currRedTrack.getNewTranID());
					t.setInvisible(currRedTrack.isSilent());
					t.getAttributeMap().put(AttributeMap.LABEL, currRedTrack.getTranName());
					break;
			}

		}
		//		for (PetrinetNode n : ilc.getNodePos().keySet()) {
		//			if (n instanceof Transition) {
		//				System.out.println(n + " - > " + ilc.getNodePos().get(n));
		//			}
		//		}

	}

}
