package org.processmining.prabhakardixit.fcnets.expansion;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.gui.controllers.NodeHighlightControlPMDUtils;
import org.processmining.reduction.ReductionTracker;

import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class ReduceUndo {
	public static void undo(PNetVisualizerController controller) {
		
		ReductionTracker rt = controller.getIPN().getCurrentRedTracker();
		controller.getMainView().getDisplay().requestFocus();
		switch (rt.getMethodName()) {
			case ABSTRACTION :
				reduceAbstraction(controller, rt);
				break;
			case LDPLACE :
				reduceLinearDependency(controller, rt, true);
				break;
			case LDTRAN :
				reduceLinearDependency(controller, rt, false);
				break;
			case RENAME :
				renameActivity(controller, rt);
				break;
			default :
				break;
		}
		
	}

	private static void renameActivity(PNetVisualizerController controller, ReductionTracker rt) {
		int tranId = rt.getNewTranID();
		Iterator iter = controller.getVisualization().getVisualGroup("graph.nodes").tuples();
		NodeItem item = null;
		while (iter.hasNext()) {
			VisualItem n = (VisualItem) iter.next();
			if (n instanceof NodeItem && n.get("type") == "TRANSITION" && n.getInt("ID") == rt.getNewTranID()) {
				item = (NodeItem) n;
			}
		}
		if (item != null)
			NodeHighlightControlPMDUtils.renameActivity(item, controller.getMainView().getNodeHighlightControlPMD(),
					rt.isSilent() ? rt.getTranName() : "", true); //for reduction - reverse the original silence action
	}

	/**
	 * @param controller
	 * @param rt
	 * @param parallePlace
	 *            -is new place
	 * @param runLayout
	 */
	private static void reduceLinearDependency(PNetVisualizerController controller, ReductionTracker rt,
			boolean parallePlace) {
		if (parallePlace)
			NodeHighlightControlPMDUtils.reduceLinearlyDependentNode(controller, rt.getNewPlaceID(), true, true, true);
		else
			NodeHighlightControlPMDUtils.reduceLinearlyDependentNode(controller, rt.getNewTranID(), true, false, true);
	}

	private static void reduceAbstraction(PNetVisualizerController controller, ReductionTracker rt) {
		NodeHighlightControlPMDUtils.reduceAbstraction(controller.getMainView().getNodeHighlightControlPMD(),
				rt.getNewPlaceID(), rt.getNewTranID(), true, true);

	}
}
