package org.processmining.prabhakardixit.fcnets.matrix;

import java.util.HashSet;
import java.util.Set;

public class Combinations {
	private static Set<Set<Integer>> allCombinations=new HashSet<Set<Integer>>();
	/* arr[]  ---> Input Array
    data[] ---> Temporary array to store current combination
    start & end ---> Staring and Ending indexes in arr[]
    index  ---> Current index in data[]
    r ---> Size of a combination to be printed */
    static void combinationUtil(int arr[], int data[], int start,
                                int end, int index, int r)
    {
        // Current combination is ready to be printed, print it
        if (index == r)
        {
        	Set<Integer> combinations = new HashSet<Integer>();
            for (int j=0; j<r; j++)
            	combinations.add(data[j]);
            allCombinations.add(combinations);
            return;
        }
 
        // replace index with all possible elements. The condition
        // "end-i+1 >= r-index" makes sure that including one element
        // at index will make a combination with remaining elements
        // at remaining positions
        for (int i=start; i<=end && end-i+1 >= r-index; i++)
        {
            data[index] = arr[i];
            combinationUtil(arr, data, i+1, end, index+1, r);
        }
    }
 
    // The main function that prints all combinations of size r
    // in arr[] of size n. This function mainly uses combinationUtil()
    static void printCombination(int arr[], int n, int r)
    {
        // A temporary array to store all combination one by one
        int data[]=new int[r];
 
        // Print all combination using temprary array 'data[]'
        combinationUtil(arr, data, 0, n-1, 0, r);
    }
    public static Set<Set<Integer>> getDataCombinations(int nbrOfElements){
    	Set<Integer> nbrSet = new HashSet<Integer>();
    	allCombinations.clear();
    	int arr[] = new int[nbrOfElements];
    	for(int i=0; i<nbrOfElements;i++){
    		arr[i] = i;
    	}
    	int n = arr.length;
    	for(int i=0;i<nbrOfElements;i++){
    		int r = i;
    		printCombination(arr, n, r);	
    	}
    	return allCombinations;
    }
}
