package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Place;

public class ChoicePlaceSets {
	private Set<Place> startChoicePlaces;
	private Set<Place> endChoicePlaces;

	public ChoicePlaceSets() {
		startChoicePlaces = new HashSet<Place>();
		endChoicePlaces = new HashSet<Place>();
	}
	
	public ChoicePlaceSets(Set<Place> placeSetStart, Set<Place> placeSetEnd) {
		startChoicePlaces = placeSetStart;
		endChoicePlaces = placeSetEnd;
	}

	public ChoicePlaceSets(Set<Place> placeStart, Place placeEnd) {
		setStartChoicePlaces(placeStart);
		setEndChoicePlaces(placeEnd);
	}


	public ChoicePlaceSets(Place placeStart, Set<Place> placeEnd) {
		setStartChoicePlaces(placeStart);
		setEndChoicePlaces(placeEnd);
	}
	
	public ChoicePlaceSets(Place placeStart, Place placeEnd) {
		setStartChoicePlaces(placeStart);
		setEndChoicePlaces(placeEnd);
	}
	
	public ChoicePlaceSets(ChoicePlaceSets cp) {
		Set<Place> startPlaces = new HashSet<Place>(cp.getStartChoicePlaces());
		Set<Place> endPlaces = new HashSet<Place>(cp.getEndChoicePlaces());
		setStartChoicePlaces(startPlaces);
		setEndChoicePlaces(endPlaces);
	}

	private void setStartChoicePlaces(Place placeStart) {
		Set<Place> startPlaces = new HashSet<>();
		startPlaces.add(placeStart);
		startChoicePlaces=startPlaces;
	}

	public void setStartChoicePlaces(Set<Place> startChoicePlacesSet) {
		Set<Place> startPlaces = new HashSet<Place>(startChoicePlacesSet);
		startChoicePlaces = startPlaces;
	}
	
	private void setEndChoicePlaces(Place placeEnd) {
		Set<Place> endPlaces = new HashSet<Place>();
		endPlaces.add(placeEnd);
		endChoicePlaces = endPlaces;
	}

	public void setEndChoicePlaces(Set<Place> endChoicePlacesSet) {
		Set<Place> endPlaces = new HashSet<Place>(endChoicePlacesSet);
		endChoicePlaces = endPlaces;
	}

	public Set<Place> getEndChoicePlaces() {
		return endChoicePlaces;
	}
	public Set<Place> getStartChoicePlaces() {
		return startChoicePlaces;
	}
}
