package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

import com.google.common.collect.Multiset;

public class CurrentActiveLoops{
	
	LoopStartEndPlaces lpse;
	private Set<Place> backLoopPlaces; //including start and end (set) place of the loop
	private Set<Transition> backLoopTransitions;
	private Set<Transition> firstMergeTrans;
	private Set<Transition> loopTransitions;
	private Set<Transition> startLoopTransitions;		//contains only the start tran of the loop
	private Set<Place> loopPlaces;
	
	public CurrentActiveLoops(Multiset<Place> placeSetStart, Multiset<Place> placeSetEnd) {
		lpse = new LoopStartEndPlaces(placeSetStart, placeSetEnd);
	}

		public CurrentActiveLoops(Set<Place> placeSync, Place placeOrg) {
		lpse.setStartLoopPlaces(placeSync);
		lpse.setEndLoopPlaces(placeOrg);
	}

	public CurrentActiveLoops(CurrentActiveLoops cp) {
		Set<Place> startPlaces = new HashSet<Place>(cp.getLPSE().getStartLoopPlaces());
		Set<Place> endPlaces = new HashSet<Place>(cp.getLPSE().getEndLoopPlaces());
		lpse.setStartLoopPlaces(startPlaces);
		lpse.setEndLoopPlaces(endPlaces);
	}

	public CurrentActiveLoops(Place placeStart, Set<Place> placeEnd) {
		lpse.setStartLoopPlaces(placeStart);
		lpse.setEndLoopPlaces(placeEnd);
	}

	public CurrentActiveLoops(Place placeStart, Place placeEnd) {
		lpse.setStartLoopPlaces(placeStart);
		lpse.setEndLoopPlaces(placeEnd);
	}

	public CurrentActiveLoops(Set<Place> placeSync, Set<Place> placeOrg) {
		lpse.setStartLoopPlaces(placeSync);
		lpse.setEndLoopPlaces(placeOrg);
	}


	public Set<Place> getBackLoopPlaces() {
		return backLoopPlaces;
	}

	public void setBackLoopPlaces(Set<Place> backLoopPlaces) {
		if (this.backLoopPlaces != null)
			this.backLoopPlaces.addAll(backLoopPlaces);
		else
			this.backLoopPlaces = new HashSet<Place>(backLoopPlaces);
	}

	public void setBackLoopPlaces(Place backLoopPlaces) {
		if (this.backLoopPlaces != null)
			this.backLoopPlaces.add(backLoopPlaces);
		else {
			this.backLoopPlaces = new HashSet<Place>();
			this.backLoopPlaces.add(backLoopPlaces);
		}
	}

	public Set<Transition> getBackLoopTransitions() {
		return backLoopTransitions;
	}
	
	public LoopStartEndPlaces getLPSE() {
		return lpse;
	}
	

	public void setBackLoopTransitions(Set<Transition> backLoopTransitions) {
		if (this.backLoopTransitions != null)
			this.backLoopTransitions.addAll(backLoopTransitions);
		else
			this.backLoopTransitions = new HashSet<Transition>(backLoopTransitions);
	}

	public void setBackLoopTransitions(Transition backLoopTransitions) {
		if (this.backLoopTransitions != null)
			this.backLoopTransitions.add(backLoopTransitions);
		else {
			this.backLoopTransitions = new HashSet<Transition>();
			this.backLoopTransitions.add(backLoopTransitions);
		}
	}

	
	public void setFirstMergeTrans(Set<Transition> firstMergeTrans) {
		if (this.firstMergeTrans != null)
			this.firstMergeTrans.addAll(firstMergeTrans);
		else
			this.firstMergeTrans = new HashSet<Transition>(firstMergeTrans);
	}

	public void setFirstMergeTrans(Transition firstMergeTrans) {
		if (this.firstMergeTrans != null)
			this.firstMergeTrans.add(firstMergeTrans);
		else {
			this.firstMergeTrans = new HashSet<Transition>();
			this.firstMergeTrans.add(firstMergeTrans);
		}
	}
	public Set<Transition> getFirstMergeTrans() {
		return firstMergeTrans;
	}

	public Set<Transition> getLoopTransitions() {
		return loopTransitions;
	}

	public void setLoopTransitions(Set<Transition> loopTransitions) {
		this.loopTransitions = loopTransitions;
	}

	public Set<Place> getLoopPlaces() {
		return loopPlaces;
	}

	public void setLoopPlaces(Set<Place> loopPlaces) {
		this.loopPlaces = loopPlaces;
	}
	
	public void setloopTransitions(Set<Transition> loopTransitions) {
		if (this.loopTransitions != null)
			this.loopTransitions.addAll(loopTransitions);
		else
			this.loopTransitions = new HashSet<Transition>(loopTransitions);
	}

	public void setloopTransitions(Transition loopTransitions) {
		if (this.loopTransitions != null)
			this.loopTransitions.add(loopTransitions);
		else {
			this.loopTransitions = new HashSet<Transition>();
			this.loopTransitions.add(loopTransitions);
		}
	}
	public void setloopPlaces(Set<Place> loopPlaces) {
		if (this.loopPlaces != null)
			this.loopPlaces.addAll(loopPlaces);
		else
			this.loopPlaces = new HashSet<Place>(loopPlaces);
	}

	public void setloopPlaces(Place loopPlaces) {
		if (this.loopPlaces != null)
			this.loopPlaces.add(loopPlaces);
		else {
			this.loopPlaces = new HashSet<Place>();
			this.loopPlaces.add(loopPlaces);
		}
	}
	public void setstartLoopTransitions(Set<Transition> startLoopTransitions) {
		if (this.startLoopTransitions != null)
			this.startLoopTransitions.addAll(startLoopTransitions);
		else
			this.startLoopTransitions = new HashSet<Transition>(startLoopTransitions);
	}

	public void setstartLoopTransitions(Transition startLoopTransitions) {
		if (this.startLoopTransitions != null)
			this.startLoopTransitions.add(startLoopTransitions);
		else {
			this.startLoopTransitions = new HashSet<Transition>();
			this.startLoopTransitions.add(startLoopTransitions);
		}
	}
	
	public Set<Transition> getstartLoopTransitions(){
		return this.startLoopTransitions;
	}
	
}
