package org.processmining.prabhakardixit.fcnets.models;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.dataquality.DetectionAndRepairModel;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.CalculateLogHeuristics.CalculateLogHeuristics;
import org.processmining.prabhakardixit.alignments.TransPairAlignment;
import org.processmining.reduction.ReductionTracker;

public class InteractivePetriNet {
	private PluginContext context;
	private UIPluginContext UIContext;
	private XLog log;
	private CalculateLogHeuristics logInfo;

	//	private JFrame frame1;

	private boolean proAnView = false; //Process Analytics View off - dont calculate any process analytics features

	private int imnIndex = 0;
	private List<InteractiveMatrixNet> imnList = new ArrayList<InteractiveMatrixNet>();
	private LinkedList<Integer> orderOfImn = new LinkedList<>();

	private boolean alignment; //toggle to show/hide the alignment view
	private boolean predictor; //toggle to show/hide the predictor view - part of editor view
	private boolean keepHistory; //toggle to keep history
	private boolean calculateAlignments; //toggle to calculate/alignments

	private boolean dataQuality = false;
	private DetectionAndRepairModel dqModel;

	private ControllerViewMode viewMode;

	//new additions end

	private String selectedActivity = new String();

	//	public SwingGraphs getGraphPanel() {
	//		return graphPanel;
	//	}

	//	public void setGraphPanel(SwingGraphs graphPanel) {
	//		this.graphPanel = graphPanel;
	//	}

	//new additions
	//Place based conformance
	//	private Set<PlaceLogs> placeLogList = new HashSet<PlaceLogs>();

	//	Map<String, Integer> stringLog = new HashMap<String, Integer>();
	//Place based conformance

	//History n future starts

	//	InteractiveMatrixNet imn;

	public PluginContext getContext() {
		return context;
	}

	public void setContext(PluginContext context) {
		this.context = context;
	}

	//	public JFrame getFrame1() {
	//		return frame1;
	//	}
	//
	//	public void setFrame1(JFrame frame1) {
	//		this.frame1 = frame1;
	//	}

	public int getImnIndex() {
		return imnIndex;
	}

	public void setImnIndex(int imnIndex) {
		this.imnIndex = imnIndex;
	}

	public List<InteractiveMatrixNet> getImnList() {
		return imnList;
	}

	public void setImnList(List<InteractiveMatrixNet> imnList) {
		this.imnList = imnList;
	}

	public void setLog(XLog log) {
		this.log = log;
	}

	public void setLogInfo(CalculateLogHeuristics logInfo) {
		this.logInfo = logInfo;
	}

	//	public Map<String, Integer> getStringLog() {
	//		return this.logInfo.getLogSeqString();
	//	}

	public Map<Transition, Set<Transition>> getTranPostTran() {
		return imnList.get(imnIndex).getTranPostTran();
	}

	public Set<Transition> getTranPostTran(Transition t) {
		return imnList.get(imnIndex).getTranPostTran(t);
	}

	public Set<String> getTranPostTranString(Transition t) {
		return imnList.get(imnIndex).getTranPostTranString(t);
	}

	public void setTranPostTran(Map<Transition, Set<Transition>> tranPostTran) {
		imnList.get(imnIndex).setTranPostTran(tranPostTran);
		;
	}

	public void addTranPostTran(Transition t, Set<Transition> tSet) {
		imnList.get(imnIndex).addTranPostTran(t, tSet);
	}

	//	public Set<PlaceLogs> getPlaceLogSet() {
	//		return placeLogList;
	//	}
	//
	//	public void setPlaceLogSet(Set<PlaceLogs> placeLog) {
	//		this.placeLogList = placeLog;
	//	}

	//	Set<InteractivePetriNet> prevIPN;
	//	Set<InteractivePetriNet> nextIPN;

	//History n future ends

	//	public SimpleMatrix getIncidenceMatrixInput() {
	//		return imnList.get(imnIndex).getIncidenceMatrixInput();
	//	}
	//
	//	public SimpleMatrix getIncidenceMatrixOutput() {
	//		return imnList.get(imnIndex).getIncidenceMatrixOutput();
	//	}

	public Set<Integer> getPlaceLDNonSiphonIndex() {
		return imnList.get(imnIndex).getPlaceLDNonSiphonIndex();
	}

	public Set<Integer> getTranLDFCs() {
		return imnList.get(imnIndex).getTranLDFCs();
	}

	public List<LDSets> getplaceLDNonSiphons() {
		return imnList.get(imnIndex).getplaceLDNonSiphons();
	}

	//	public SimpleMatrix getplaceLDNonSiphonsInput() {
	//		return imnList.get(imnIndex).getplaceLDNonSiphonsInput();
	//	}
	//
	//	public SimpleMatrix getplaceLDNonSiphonsOutput() {
	//		return imnList.get(imnIndex).getplaceLDNonSiphonsOutput();
	//	}
	//
	//	public SimpleMatrix getTranLDInput() {
	//		return imnList.get(imnIndex).getTranLDInput();
	//	}
	//
	//	public SimpleMatrix getTranLDOutput() {
	//		return imnList.get(imnIndex).getTranLDOutput();
	//	}
	//
	//	public SimpleMatrix getPlaceLDInput() {
	//		return imnList.get(imnIndex).getPlaceLDInput();
	//	}
	//
	//	public SimpleMatrix getPlaceLDOutput() {
	//		return imnList.get(imnIndex).getPlaceLDOutput();
	//	}
	//	//
	//	public List<LDSets> getTranLDFreeChoice() {
	//		return imnList.get(imnIndex).getTranLDFreeChoice();
	//	}

	//	public SimpleMatrix getTranLDFreeChoiceMatrixInput() {
	//		return imnList.get(imnIndex).getTranLDFreeChoiceMatrixInput();
	//	}
	//
	//	public SimpleMatrix getTranLDFreeChoiceMatrixOutput() {
	//		return imnList.get(imnIndex).getTranLDFreeChoiceMatrixOutput();
	//	}

	public Integer getPlaceId(Place p) {
		return imnList.get(imnIndex).getPlaceId(p);
	}

	public void setPlaceId(Place p, Integer i) {
		imnList.get(imnIndex).setPlaceId(p, i);
	}

	public Map<Place, Integer> getAllPlaceId() {
		return imnList.get(imnIndex).getAllPlaceId();
	}

	public Integer getTranId(Transition t) {
		return imnList.get(imnIndex).getTranId(t);
	}

	public void setTranId(Transition t, Integer i) {
		imnList.get(imnIndex).setTranId(t, i);
	}

	public Map<Transition, Integer> getAllTranId() {
		return imnList.get(imnIndex).getAllTranId();
	}

	public InteractivePetriNet(String selectedActivity) {
		this.selectedActivity = selectedActivity;
	}

	public InteractivePetriNet(PetriNetMap pnmap, XLog log, UIPluginContext context) {
		//this.acceptingPetriNetArray = apn;
		//		this.pnMapList.add(pnmap);
		imnIndex = 0;
		InteractiveMatrixNet imn = new InteractiveMatrixNet();
		imnList.add(imn);
		setselectedPetriNetMap(pnmap);
		this.UIContext = context;
		this.context = context;
		this.log = log;
		//		graphPanel = SwingGraphs.getGraphs(this);
		logInfo = new CalculateLogHeuristics(log);

		//keep history 
		setKeepHistory(true);

		setViewMode(ControllerViewMode.VIEWONLY);
		//		graphPanel3 = new StackedChart("title", this);
		//		frame1 = new JFrame();
		//		SwingGraphs sg = new SwingGraphs("Graphs", this);
		//		SwingGraphs.getGraphs(this);
		//		placeLog1.setPlace(PetrinetUtils.getMiddlePlace(pnmap.getPetriNet()));
		//		placeLogList.add(placeLog1);

	}

	public InteractivePetriNet(PetriNetMap pnmap) {
		//		this.pnMapList.add(pnmap);
		setselectedPetriNetMap(pnmap);
	}

	public PetriNetMap getselectedPetriNetMap() {
		return imnList.get(imnIndex).getselectedPetriNetMap();
	}

	public void setselectedPetriNetMap(PetriNetMap pnMap) {
		imnList.get(imnIndex).setselectedPetriNetMap(pnMap);
	}

	public void setSelectedActivity(String selectedActivity) {
		this.selectedActivity = selectedActivity;
	}

	public String getSelectedActivity() {
		return selectedActivity;
	}

	//	public List<PetriNetMap> getPetriNetMapList() {
	//		return pnMapList;
	//	}
	//
	//	public void setPetriNetMapList(List<PetriNetMap> pnMapList) {
	//		this.pnMapList = pnMapList;
	//	}

	//	public Map<String, Map<String, Double>> getFollowsRelations() {
	//		return logInfo.followsMap;
	//	}
	//
	//	public Map<String, Map<String, Double>> getCoOccorsRelations() {
	//		return logInfo.coOccursMap;
	//	}

	public Set<String> getEventNames() {
		return logInfo.events;
	}

	public CalculateLogHeuristics getLogInfo() {
		return logInfo;
	}

	//	public void setInciMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setInciMatrixInput(m);
	//	}
	//
	//	public void setInciMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setInciMatrixOutput(m);
	//		;
	//	}

	//	public void setTranLDMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setTranLDMatrixInput(m);
	//	}
	//
	//	public void setTranLDMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setTranLDMatrixOutput(m);
	//	}
	//
	//	public void setPlaceLDMatrixInput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setPlaceLDMatrixInput(m);
	//	}
	//
	//	public void setPlaceLDMatrixOutput(SimpleMatrix m) {
	//		imnList.get(imnIndex).setPlaceLDMatrixOutput(m);
	//	}

	public Place getPlaceBasedOnID(int id) {
		return imnList.get(imnIndex).getPlaceBasedOnID(id);
	}

	//tranId in viz is tran+1000
	public Transition getTranBasedOnID(int id) {
		return imnList.get(imnIndex).getTranBasedOnID(id);
	}

	public PluginContext getPromContext() {
		return context;
	}

	public UIPluginContext getUIContext() {
		return UIContext;
	}

	public XLog getLog() {
		return log;
	}

	public void selectPrevIndex() {
		if (imnIndex != 0)
			imnIndex--;
	}

	public void selectNextIndex() {
		if (imnIndex < imnList.size() - 1)
			imnIndex++;
	}

	public InteractiveMatrixNet getInteractiveMatNet() {
		return this.imnList.get(imnIndex);
	}

	public void updateInteractiveMatNet(ReductionTracker rd) {
		InteractiveMatrixNet imn = new InteractiveMatrixNet(this.getInteractiveMatNet(), true);
		imnList.add(imn);
		orderOfImn.add(imnIndex);
		imnIndex = imnList.size() - 1;
		imnList.get(imnIndex).setCurrentRedTracker(rd);


	}

	public void reduceInteractiveMatNet() {
		//		InteractiveMatrixNet imn = new InteractiveMatrixNet(this.getInteractiveMatNet());
		//		this.getInteractiveMatNet().setGraph(prevGraph);
		//		imnList.add(imn);
		imnIndex--;

	}

	public Set<String> getSortedEventNames() {
		return logInfo.getActivities();
	}

	public List<LDSets> getAllLdPlaceInfo() {
		return imnList.get(imnIndex).getLdPlaceInfo();
	}

	public void addLdPlaceInfo(int rowId, int negativeid, int positiveid) {
		imnList.get(imnIndex).addLdPlaceInfo(rowId, negativeid, positiveid);
	}

	public List<LDSets> getAllLdTranInfo() {
		return imnList.get(imnIndex).getLdTranInfo();
	}

	public void addLdTranInfo(int colId, int negativeid, int positiveid) {
		imnList.get(imnIndex).addLdTranInfo(colId, negativeid, positiveid);
	}

	public void setLdTranInfo(LDSets ldset) {
		imnList.get(imnIndex).setLdTranInfo(ldset);
	}

	//	public void setParallelPlaceMap(Integer placeId, Set<Integer> places) {
	//		imnList.get(imnIndex).setPlaceParallelMap(placeId, places);
	//	}
	//
	//	public void setParallelPlaceMap(Integer placeId, Integer places) {
	//		imnList.get(imnIndex).setPlaceParallelMap(placeId, places);
	//	}
	//
	//	public Set<Integer> getParallelPlaceMap(Integer placeId) {
	//		return imnList.get(imnIndex).getPlaceParallelMap(placeId);
	//	}
	//	
	//	public Map<Integer,Set<Integer>> getPlaceParallelMapAll(){
	//		return imnList.get(imnIndex).getPlaceParallelMapAll();
	//	}

	public void updateLdTranInfo(int listID, int newNegId, int newPosId) {
		imnList.get(imnIndex).getLdTranInfo().get(listID).updateNegativeId(newNegId);
		imnList.get(imnIndex).getLdTranInfo().get(listID).updatePositiveId(newPosId);

	}

	//	public void setRrefMainPath(int id){
	//		imnList.get(imnIndex).setRrefMainPath(id);
	//	}
	//	public Set<Integer> getRrefMainPath(){
	//		return imnList.get(imnIndex).getRrefMainPath();
	//	}
	//
	//	public void setLoopTrans(int id){
	//		imnList.get(imnIndex).setLoopTrans(id);
	//	}
	//	public Set<Integer> getLoopTrans(){
	//		return imnList.get(imnIndex).getLoopTrans();
	//	}
	//	public void setLoopPlaces(int id){
	//		imnList.get(imnIndex).setLoopPlaces(id);
	//	}
	//	public Set<Integer> getLoopPlaces(){
	//		return imnList.get(imnIndex).getLoopPlaces();
	//	}

	public Set<LDSets> getLdPlaceMapForTranLD(Integer key) {
		return imnList.get(imnIndex).getLdPlaceMapForTranLD(key);
	}

	public void setLdPlaceMapForTranLD(Integer key, LDSets lds) {
		imnList.get(imnIndex).setLdPlaceMapForTranLD(key, lds);
	}

	public void removeLdPlaceMapForTranLD(Integer key, LDSets lds) {
		imnList.get(imnIndex).removeLdPlaceMapForTranLD(key, lds);
	}

	public Map<Integer, Set<Integer>> getAllLdPlaceMapForTranLD() {
		return imnList.get(imnIndex).getAllLdPlaceMapForTranLD();
	}

	public Set<LDSets> getAllTranLDFCs() {
		return imnList.get(imnIndex).getAllTranLDFCs();
	}

	//red tracker starts
	public ReductionTracker getCurrentRedTracker() {
		return imnList.get(imnIndex).getCurrentRedTracker();
	}

	public ReductionTracker getNextRedTracker() {
		return imnList.get(imnIndex).getNextRedTracker();
	}

	public void setCurrentRedTracker(ReductionTracker r) {
		imnList.get(imnIndex).setCurrentRedTracker(r);
	}

	public void setNextRedTracker(ReductionTracker r) {
		imnList.get(imnIndex).setNextRedTracker(r);
	}

	//red tracker ends

	//pairwise alignment starts
	//	public void setPairwiseAlignmentInfo(List<TraceLevelPairwiseInfo> pairwiseAlignmentInfo) {
	//		imnList.get(imnIndex).setPairwiseAlignmentInfo(pairwiseAlignmentInfo);
	//	}

	//	public List<AggregatedTraceLevelPairwiseInfo> getPairwiseAlignmentInfo() {
	//		return logInfo.traceLevelInfo;
	//	}
	//
	//	public AggregatedTraceLevelPairwiseInfo getPairwiseAlignmentInfoBasedOnIds(Set<Integer> traceIDs) {
	//		for (AggregatedTraceLevelPairwiseInfo tlpi : logInfo.traceLevelInfo)
	//			if (tlpi.getId().containsAll(traceIDs))
	//				return tlpi;
	//
	//		return null;
	//	}

	public void setTranPairs(Set<TransPairAlignment> tranPairs) {
		logInfo.tranPairs = tranPairs;
	}

	public Set<TransPairAlignment> getTranPairs() {
		return logInfo.tranPairs;
	}

	//pairwise alignment ends

	//map of transition linear dependencies
	//	public Map<Set<Integer>, Set<Integer>> getMapLDTrans() {
	//		return imnList.get(imnIndex).getMapLDTrans();
	//	}

	public Map<Transition, Integer> getAggrSyncMoves() {
		return imnList.get(imnIndex).getAggrSyncMoves();
	}

	public void addToAggrSyncMoves(Transition t, Integer addVal) {
		Map<Transition, Integer> aggrSync = getAggrSyncMoves();
		if (aggrSync.containsKey(t)) {
			aggrSync.put(t, aggrSync.get(t) + addVal);
		} else {
			aggrSync.put(t, addVal);
		}
	}

	public void subFromAggrSyncMoves(Transition t, Integer subVal) {
		Map<Transition, Integer> aggrSync = getAggrSyncMoves();
		if (aggrSync.containsKey(t)) {
			aggrSync.put(t, aggrSync.get(t) - subVal);
		} else {
			aggrSync.put(t, 0);
		}
	}

	public Map<String, Integer> getAggrLogMoves() {
		return imnList.get(imnIndex).getAggrLogMoves();
	}

	public void addToAggrLogMoves(String t, Integer addVal) {
		Map<String, Integer> aggrLog = getAggrLogMoves();
		if (aggrLog.containsKey(t)) {
			aggrLog.put(t, aggrLog.get(t) + addVal);
		} else {
			aggrLog.put(t, addVal);
		}
	}

	public void subFromAggrLogMoves(String l, Integer subVal) {
		Map<String, Integer> aggrLog = getAggrLogMoves();
		if (aggrLog.containsKey(l)) {
			aggrLog.put(l, aggrLog.get(l) - subVal);
		} else {
			aggrLog.put(l, 0);
		}
	}

	public Map<Transition, Integer> getAggrModelMoves() {
		return imnList.get(imnIndex).getAggrModelMoves();
	}

	public void addToAggrModelMoves(Transition t, Integer addVal) {
		Map<Transition, Integer> aggrModel = getAggrModelMoves();
		if (aggrModel.containsKey(t)) {
			aggrModel.put(t, aggrModel.get(t) + addVal);
		} else {
			aggrModel.put(t, addVal);
		}
	}

	public void subFromAggrModelMoves(Transition t, Integer subVal) {
		Map<Transition, Integer> aggrModel = getAggrModelMoves();
		if (aggrModel.containsKey(t)) {
			aggrModel.put(t, aggrModel.get(t) - subVal);
		} else {
			aggrModel.put(t, 0);
		}
	}

	public boolean isAlignmentMode() {
		return alignment;
	}

	public void setAlignmentMode(boolean alignment) {
		this.alignment = alignment;
	}

	public boolean isPredictorMode() {
		return predictor;
	}

	public void setPredictorMode(boolean predictor) {
		this.predictor = predictor;
	}

	public boolean isKeepHistory() {
		return keepHistory;
	}

	public void setKeepHistory(boolean keepHistory) {
		this.keepHistory = keepHistory;
	}

	public ControllerViewMode getViewMode() {
		return viewMode;
	}

	public void setViewMode(ControllerViewMode viewMode) {
		this.viewMode = viewMode;
	}

	public boolean isCalculateAlignments() {
		return calculateAlignments;
	}

	public void setCalculateAlignments(boolean calculateAlignments) {
		this.calculateAlignments = calculateAlignments;
	}

	public List<Set<Integer>> getInputOutPlaces() {
		return imnList.get(imnIndex).getInputOutPlaces();
	}

	public void setInputOutPlaces(List<Set<Integer>> inputOutNodeCombo) {
		imnList.get(imnIndex).setInputOutPlaces(inputOutNodeCombo);
	}

	public List<Set<Integer>> getInputOutTransitions() {
		return imnList.get(imnIndex).getInputOutTransitions();
	}

	public void setInputOutTransitions(List<Set<Integer>> inputOutTrans) {
		imnList.get(imnIndex).setInputOutTransitions(inputOutTrans);
	}

	public int getPrevImnIndex(int currId) {
		return orderOfImn.get(currId - 1);
	}

	public boolean isDataQuality() {
		return dataQuality;
	}

	public void setDataQuality(boolean dataQuality) {
		this.dataQuality = dataQuality;
	}

	public DetectionAndRepairModel getDqModel() {
		return dqModel;
	}

	public void setDqModel(DetectionAndRepairModel dqModel) {
		this.dqModel = dqModel;
	}
}
