package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Place;

import com.google.common.collect.HashMultiset;
import com.google.common.collect.Multiset;

public class LoopStartEndPlaces {
	private Multiset<Place> startLoopPlaces;
	private Multiset<Place> endLoopPlaces;

	public LoopStartEndPlaces(Multiset<Place> placeSetStart, Multiset<Place> placeSetEnd) {
		startLoopPlaces = placeSetStart;
		endLoopPlaces = placeSetEnd;
	}

	public LoopStartEndPlaces() {
		// TODO Auto-generated constructor stub
	}

	public LoopStartEndPlaces(Set<Place> placeSync, Place placeOrg) {
		setStartLoopPlaces(placeSync);
		setEndLoopPlaces(placeOrg);
	}
	public LoopStartEndPlaces(LoopStartEndPlaces cp) {
		Set<Place> startPlaces = new HashSet<Place>(cp.getStartLoopPlaces());
		Set<Place> endPlaces = new HashSet<Place>(cp.getEndLoopPlaces());
		setStartLoopPlaces(startPlaces);
		setEndLoopPlaces(endPlaces);
	}
	
	public LoopStartEndPlaces(Place placeStart, Set<Place> placeEnd) {
		setStartLoopPlaces(placeStart);
		setEndLoopPlaces(placeEnd);
	}
	
	public LoopStartEndPlaces(Place placeStart, Place placeEnd) {
		setStartLoopPlaces(placeStart);
		setEndLoopPlaces(placeEnd);
	}
	public LoopStartEndPlaces(Set<Place> placeSync, Set<Place> placeOrg) {
		setStartLoopPlaces(placeSync);
		setEndLoopPlaces(placeOrg);
	}
	void setEndLoopPlaces(Place placeOrg) {
		Multiset<Place> endPlaces = HashMultiset.create();
		endPlaces.add(placeOrg);
		endLoopPlaces = endPlaces;
	}

	public Multiset<Place> getEndLoopPlaces() {
		return endLoopPlaces;
	}
	public void setStartLoopPlaces(Place startLoopPlacesSet) {
		Multiset<Place> startPlaces = HashMultiset.create();
		startPlaces.add(startLoopPlacesSet);
		startLoopPlaces = startPlaces;
	}
	
	public void setStartLoopPlaces(Multiset<Place> startLoopPlacesSet) {
		Multiset<Place> startPlaces = HashMultiset.create(startLoopPlacesSet);
		startLoopPlaces = startPlaces;
	}

	public Multiset<Place> getStartLoopPlaces() {
		return startLoopPlaces;
	}

	public void setStartLoopPlaces(Set<Place> startLoopPlacesSet) {
		Multiset<Place> startPlaces = HashMultiset.create(startLoopPlacesSet);
		startLoopPlaces = startPlaces;
	}

	public void setEndLoopPlaces(Set<Place> endLoopPlacesSet) {
		Multiset<Place> endPlaces = HashMultiset.create(endLoopPlacesSet);
		endLoopPlaces = endPlaces;
	}

	public void setEndLoopPlaces(Multiset<Place> endPlaces) {
		startLoopPlaces = endPlaces;
	}

	public void copyPlace(Place orgP, Place newP) {
		int count = 0;
		for (Place p : startLoopPlaces)
			if (p.equals(orgP))
				count++;
		for (int i = 0; i < count; i++)
			if (!startLoopPlaces.contains(newP))
				startLoopPlaces.add(newP);

		count = 0;
		for (Place p : endLoopPlaces)
			if (p.equals(orgP))
				count++;
		for (int i = 0; i < count; i++)
			if (!endLoopPlaces.contains(newP))
				endLoopPlaces.add(newP);
	}

	public void remove(Place p) {
		startLoopPlaces.remove(p);
		endLoopPlaces.remove(p);
	}
}
