package org.processmining.prabhakardixit.fcnets.models;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class ParallelTransitionSets {
	private Set<Transition> startParallelTransitions;
	private Set<Transition> endParallelTransitions;

	public ParallelTransitionSets(Set<Transition> transSetStart, Set<Transition> transSetEnd) {
		startParallelTransitions= transSetStart;
		endParallelTransitions = transSetEnd;
	}

	public ParallelTransitionSets(Set<Transition> transStart, Transition transEnd) {
		setStartParallelTransitions(transStart);
		setEndParallelTransitions(transEnd);
	}


	public ParallelTransitionSets(Transition TransitionStart, Set<Transition> TransitionEnd) {
		setStartParallelTransitions(TransitionStart);
		setEndParallelTransitions(TransitionEnd);
	}
	
	public ParallelTransitionSets(Transition TransitionStart, Transition TransitionEnd) {
		setStartParallelTransitions(TransitionStart);
		setEndParallelTransitions(TransitionEnd);
	}
	
	public ParallelTransitionSets(ParallelTransitionSets cp) {
		Set<Transition> startTransitions = new HashSet<Transition>(cp.getStartParallelTransitions());
		Set<Transition> endTransitions = new HashSet<Transition>(cp.getEndParallelTransitions());
		setStartParallelTransitions(startTransitions);
		setEndParallelTransitions(endTransitions);
	}

	private void setStartParallelTransitions(Transition TransitionStart) {
		Set<Transition> startTransitions = new HashSet<>();
		startTransitions.add(TransitionStart);
		startParallelTransitions=startTransitions;
	}

	public void setStartParallelTransitions(Set<Transition> startParallelTransitionsSet) {
		Set<Transition> startTransitions = new HashSet<Transition>(startParallelTransitionsSet);
		startParallelTransitions = startTransitions;
	}
	
	private void setEndParallelTransitions(Transition TransitionEnd) {
		Set<Transition> endTransitions = new HashSet<Transition>();
		endTransitions.add(TransitionEnd);
		endParallelTransitions = endTransitions;
	}

	public void setEndParallelTransitions(Set<Transition> endParallelTransitionsSet) {
		Set<Transition> endTransitions = new HashSet<Transition>(endParallelTransitionsSet);
		endParallelTransitions = endTransitions;
	}

	public Set<Transition> getEndParallelTransitions() {
		return endParallelTransitions;
	}
	public Set<Transition> getStartParallelTransitions() {
		return startParallelTransitions;
	}
}
