package org.processmining.prabhakardixit.featureSelection;

import org.processmining.plugins.petrinet.replayresult.StepTypes;
import org.processmining.prabhakardixit.processanalytics.models.ClassificationTypes;

public class ConfigureOutputs extends SelectFeatures {

	public static void initiate(ClassificationTypes classificationType) {
		outputs.clear();
		outputAttVals.clear();
		
		switch (classificationType) {
			case TRACEFITNESS :
				outputs.put("output0", "Yes" );
				outputs.put("output1", "No");
				outputs.put("output2", "NA");
				for (String key : outputs.keySet()) {
//					outputAttVals.add(outputs.get(key));
				}
				break;
			case ACTIVITYFITNESS :
//				activityName = "a";
				outputs.put("output0", "LogMove");
				outputs.put("output1", "ModelMove");
				outputs.put("output2", "SyncMove");
				for (String key : outputs.keySet()) {
//					outputAttVals.add(outputs.get(key));
				}
				break;
		}

//		eval = Evaluators.RELIEF;
	}

	public static String getOutputVals(StepTypes stepTypes) {
		String output = "";
		switch(stepTypes){
			case L :
				output = outputs.get("output0");
				break;
			case MREAL :
				output = outputs.get("output1");
				break;
			case LMGOOD :
				output = outputs.get("output2");
				break;
		}
		return output;
	}

	public static String getOutputVals(Double fitVal) {
		String output = "";
		if (fitVal >= fitnessThreshold)
			output = outputs.get("output0");
		else if (fitVal < fitnessThreshold)
			output = outputs.get("output1");
		else
			output = outputs.get("output3");
		return output;
	}
	
	public static String getExptOutputVals(String val) {
		String output = "";
		if (val.equals("ja"))
			output = outputs.get("output0");
		else if (val.equals("nee"))
			output = outputs.get("output1");
		else
			output = outputs.get("output2");
		return output;
	}
}
