package org.processmining.prabhakardixit.pluginsPN;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.prabhakardixit.pnets.PetrinetCompare;

@Plugin(name = "Petri net generato13r", parameterLabels = {
		"Petri net 1", "Petri net 2"}, returnLabels = { "Structurally same Petri nets" }, returnTypes = { Boolean.class })
public class ComparePetriNets {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * @param context 
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log 
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	private static boolean comparePN(UIPluginContext context, Petrinet pn1, Petrinet pn2){
		boolean same=false;
		
		same = PetrinetCompare.comparePetriNets(pn1, pn2);
		return same;
	}
	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "Your p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati13on", requiredParameterLabels = { 0 , 1})
	public boolean yourDefaultPlugin(UIPluginContext context, Petrinet pn1, Petrinet pn2) throws IllegalAccessException,
			InstantiationException {
		
			return comparePN(context,pn1,pn2);
		
	}
}
