package org.processmining.prabhakardixit.pluginsPN;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.synthesis.CreateIPN;

@Plugin(name = "Petri net editor with alignment and predictor view", parameterLabels = {
		"Log "}, returnLabels = { "Name of your output" }, returnTypes = { InteractivePetriNet.class })
public class EditorAlignmentPredictorPlugin {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log 
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public InteractivePetriNet yourPrivatePlugin(UIPluginContext context, XLog log)
			throws IllegalAccessException, InstantiationException {
		//AcceptingPetriNetArray apn =  tempRun.temprun(pn);
		//PetriNetMap pnMap = new PetriNetMap(pn);
		//List<PetriNetMap> pnMapList=  tempRun.temprun(pnMap);
		//List<PetriNetMap> pnMapList=  org.processmining.prabhakardixit.fcnets.synthesis.SynthesisTempRun.temprun(pnMap);
		//VisualizeAcceptingPetriNetArrayPlugin a = new VisualizeAcceptingPetriNetArrayPlugin();
		//a.visualize(context, apn);
		//InteractivePetriNet ipn = new InteractivePetriNet(pnMapList, "");
		//ipn.setAcceptingPetriNetArray(apn);
		//CalculateLogHeuristics.calculateRelations(log);
		return CreateIPN.createIPN(log,context,true,true,true); 
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Petri Net generati11on", requiredParameterLabels = { 0})
	public InteractivePetriNet yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {
		
			return yourPrivatePlugin(context,log);
			
		
	}
}
