package org.processmining.prabhakardixit.pluginsPN;

import java.util.HashSet;
import java.util.Set;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.reduction.Reduction;

@Plugin(name = "Reduce petrinet 18", parameterLabels = { "Petrinet " }, returnLabels = { "Name of your output" }, returnTypes = { Petrinet.class })
public class ReductionPlugin {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public Petrinet yourPrivatePlugin(PluginContext context, Petrinet pn) throws IllegalAccessException,
			InstantiationException {
		Reduction rd = new Reduction(pn,context);
		return pn;
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Reduce petrinet 118", requiredParameterLabels = { 0 })
	public Petrinet yourDefaultPlugin(UIPluginContext context, Petrinet log) throws IllegalAccessException,
			InstantiationException {

		return yourPrivatePlugin(context, log);

	}
	
	
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Reduce petrinet 118", requiredParameterLabels = { 0 })
	public Petrinet reduceNet(PluginContext context, Petrinet net, Set<PetrinetNode> keepNodes) {
		Reduction rd = new Reduction(net,keepNodes);
		return net;
		

	}
}
