package org.processmining.prabhakardixit.processanalytics;

import java.awt.Color;
import java.awt.Component;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer;
import org.jfree.chart.renderer.category.CategoryItemRenderer;
import org.jfree.chart.renderer.category.StandardBarPainter;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;


public class SwingGraph {

	public static void createHistogram(JPanel frame, Map<String, Map<Double, Double>> displayView) {
		JScrollPane scrp = new JScrollPane(histogram(displayView));
		frame.getRootPane().removeAll();
		frame.setName("Graphs");
		frame.getRootPane().add(scrp);
		frame.getRootPane().revalidate();
		frame.getRootPane().repaint();
		frame.revalidate();
		frame.repaint();				
	}
	
	
	public static void createHistogramWithStringCategory(JPanel frame, Map<String, Map<String, Double>> displayView) {
//		JScrollPane scrp = new JScrollPane(histogramWithString(displayView));
//		frame.setLayout(new java.awt.BorderLayout());
//		frame.removeAll();
//		frame.setSize(1000, 500);
//		frame.add(histogramWithString(displayView),BorderLayout.CENTER);
//		frame.add(new JButton("t2"));
//		frame.validate();
//		frame.revalidate();
//		frame.repaint();	
//		return frame;
		
		JScrollPane scrp = new JScrollPane(histogramWithString(displayView));
		frame.removeAll();
		frame.setSize(1000, 500);
		frame.add(scrp);
		frame.revalidate();
		frame.repaint();
	}
	
	
	public static void createStackedChart(JPanel frame, Map<String, Map<Double, Double>> displayView) {
		JScrollPane scrp = new JScrollPane(stackedChart(displayView));
//		frame.getRootPane().removeAll();
		frame.setName("Graphs");
//		frame.getRootPane().add(scrp);
//		frame.getRootPane().revalidate();
//		frame.getRootPane().repaint();
		frame.removeAll();
		frame.add(stackedChart(displayView));
		frame.revalidate();
		frame.repaint();				
	}
	private static Map<String, Map<Double, Double>> getSortedDisplayView(Map<String, Map<Double, Double>> displayView) {
		// TODO Auto-generated method stub
		return null;
	}

	private static Component histogram(Map<String, Map<Double, Double>> displayView) {
		JPanel panel = new JPanel();

		final JFreeChart chart = ChartFactory.createBarChart("Bar Chart ", // chart title
				"Time", // domain axis label
				"#Of Moves", // range axis label
				createDataset1(displayView), // data
				PlotOrientation.VERTICAL, // orientation
				true, // include legend
				true, // tooltips?
				false // URLs?
				);
		final ChartPanel chartPanel = new ChartPanel(chart);
		//        chartPanel.setPreferredSize(new Dimension(500, 270));
		panel.add(chartPanel);
		return panel;

	}
	
	private static Component histogramWithString(Map<String, Map<String, Double>> displayView) {
		JPanel panel = new JPanel();
		JFrame f = new JFrame();
		final JFreeChart chart = ChartFactory.createBarChart(" ", // chart title
				"Time", // domain axis label
				"Count", // range axis label
				createDatasetWithString(displayView), // data
//				createDataset(),
				PlotOrientation.VERTICAL, // orientation
				true, // include legend
				true, // tooltips?
				false // URLs?
				);
		
		final CategoryPlot plot = chart.getCategoryPlot();

		plot.setForegroundAlpha(0.8f);
		plot.setBackgroundPaint(Color.white);
		plot.setDomainGridlinePaint(Color.white);
		plot.setRangeGridlinePaint(Color.white);
		((BarRenderer) plot.getRenderer()).setBarPainter(new StandardBarPainter());
		
		final ChartPanel chartPanel = new ChartPanel(chart);
		//        chartPanel.setPreferredSize(new Dimension(500, 270));
		panel.add(chartPanel);
		f.add(chartPanel);
		
//		ChartPanel cp = new ChartPanel();
		return chartPanel;

	}

	private static CategoryDataset createDataset1(Map<String, Map<Double, Double>> displayView) {

		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		for (String activity : displayView.keySet()) {
			for (Double category : displayView.get(activity).keySet()) {
				dataset.addValue(displayView.get(activity).get(category), activity,category);
			}
		}
		return dataset;
	}
	
	private static CategoryDataset createDatasetWithString(Map<String, Map<String, Double>> displayView) {

		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		for (String activity : displayView.keySet()) {
			for (String category : displayView.get(activity).keySet()) {
				dataset.addValue(displayView.get(activity).get(category), activity,category);
			}
		}
		return dataset;
	}
	
	private static Component stackedChart(Map<String, Map<Double, Double>> displayView) {
		JPanel panel = new JPanel();

		 final JFreeChart chart = ChartFactory.createStackedAreaChart(
		            "Stacked Area Chart",      // chart title
		            "Category",                // domain axis label
		            "Value",                   // range axis label
		            createDataset1(displayView),                   // data
		            PlotOrientation.VERTICAL,  // orientation
		            true,                      // include legend
		            true,
		            false
		        );
	      chart.setBackgroundPaint(Color.white);
panel.setSize(800, 200);
	        final CategoryPlot plot = (CategoryPlot) chart.getPlot();
	        plot.setForegroundAlpha(0.5f);
	        plot.setBackgroundPaint(Color.lightGray);
	        plot.setDomainGridlinePaint(Color.white);
	        plot.setRangeGridlinePaint(Color.white);
	        
	        final CategoryAxis domainAxis = plot.getDomainAxis();
	        domainAxis.setLowerMargin(0.0);
	        domainAxis.setUpperMargin(0.0);

	        // change the auto tick unit selection to integer units only...
	        final NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
	        rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

	        final CategoryItemRenderer renderer = plot.getRenderer();
	        renderer.setItemLabelsVisible(true);

		final ChartPanel chartPanel = new ChartPanel(chart);
		//        chartPanel.setPreferredSize(new Dimension(500, 270));
		panel.add(chartPanel);
		return panel;

	}

	  private static CategoryDataset createDataset( ) {
	      final String fiat = "FIAT";        
	      final String audi = "AUDI";        
	      final String ford = "FORD";        
	      final String speed = "Speed";        
	      final String millage = "Millage";        
	      final String userrating = "User Rating";        
	      final String safety = "safety";        
	      final DefaultCategoryDataset dataset = 
	      new DefaultCategoryDataset( );  

	      dataset.addValue( 1.0 , fiat , speed );        
	      dataset.addValue( 3.0 , fiat , userrating );        
	      dataset.addValue( 5.0 , fiat , millage ); 
	      dataset.addValue( 5.0 , fiat , safety );           

	      dataset.addValue( 5.0 , audi , speed );        
	      dataset.addValue( 6.0 , audi , userrating );       
	      dataset.addValue( 10.0 , audi , millage );        
	      dataset.addValue( 4.0 , audi , safety );

	      dataset.addValue( 4.0 , ford , speed );        
	      dataset.addValue( 2.0 , ford , userrating );        
	      dataset.addValue( 3.0 , ford , millage );        
	      dataset.addValue( 6.0 , ford , safety );               

	      return dataset; 
	   }
}