package org.processmining.prabhakardixit.viz;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.humbertogarciacaballero.models.gui.PNetVisualizerGUI;
import org.processmining.humbertogarciacaballero.models.model.NodeType;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;
import org.processmining.humbertogarciacaballero.models.model.SoundnessInformation;
import org.processmining.humbertogarciacaballero.plugins.PluginUtils;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;
import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtils;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;
import org.processmining.prabhakardixit.fcnets.synthesis.VizGraphParametersUtils;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsVizViews;
import org.processmining.prabhakardixit.processanalytics.RecomputeAlignments;
import org.processmining.prabhakardixit.processanalytics.models.ChartView;
import org.processmining.prabhakardixit.processanalytics.models.GraphData;
import org.processmining.prabhakardixit.processanalytics.models.ProcessView;
import org.processmining.prabhakardixit.processanalytics.models.TimeView;

import prefuse.data.Graph;
import prefuse.data.Node;
import prefuse.util.PrefuseLib;

@Plugin(name = "@1 New Petri net visualizer", returnLabels = { "Visualized Petrinet" }, returnTypes = { JComponent.class }, parameterLabels = { "Petri net" }, userAccessible = false)
@Visualizer
public class InteractivePetrinetVisualizer {

	@PluginVariant(requiredParameterLabels = { 0 })
	//	public JComponent asdfasdf(PluginContext context, Petrinet net) {
	//		return new PNetVisualizerGUI(petrinetToGraph(net)).getRootPane();
	//	}
	public JComponent asdfasdf(PluginContext context, InteractivePetriNet net) {
		if (net.getselectedPetriNetMap().getMapPlaces().size() == 3)
			MatrixUtils.initiate(net);
		Marking m = new Marking();
		//		m.add(getInitialMarking(n));
		SoundnessInformation information = new SoundnessInformation();
		Graph graph = PluginUtils.netToGraph(context, net.getselectedPetriNetMap().getPetriNet(), null, information,
				null);
		PNRepResult replayResult = RecomputeAlignments.recalculateAlignments(net.getPromContext(), net.getLog(), net
				.getselectedPetriNetMap().getPetriNet(), 10, new HashSet<Transition>(net.getselectedPetriNetMap()
				.getPetriNet().getTransitions()));
		ProcessAnalyticsVizViews pa = new ProcessAnalyticsVizViews(replayResult, net.getselectedPetriNetMap()
				.getPetriNet(), net.getLog(), TimeView.HOURS, ProcessView.CaseStart, ChartView.HISTOGRAM,
				GraphData.SyncMovesOnly);
		//		return new PNetVisualizerGUI(petrinetToGraph(net),net).getRootPane();
		return new PNetVisualizerGUI(graph, net, pa).getRootPane();
	}

	//	public static JComponent asdfasdf(Petrinet net) {
	//		return new PNetVisualizerGUI(petrinetToGraph(net)).getRootPane();
	//	}
	public static JComponent asdfasdf(InteractivePetriNet net) {
		if (net.getselectedPetriNetMap().getPetriNet().getPlaces().size() == 3)
			MatrixUtils.initiate(net);
		Marking m = new Marking();
		//		m.add(getInitialMarking(n));
		SoundnessInformation information = new SoundnessInformation();
		Graph graph = PluginUtils.netToGraph(null, net.getselectedPetriNetMap().getPetriNet(), null, information, net,
				null);
		//		return new PNetVisualizerGUI(petrinetToGraph(net),net).getRootPane();
		//		PNRepResult replayResult = RecomputeAlignments.recalculateAlignments(net.getPromContext(), net.getLog(), net.getselectedPetriNetMap().getPetriNet(), 10, new HashSet<Transition>(net.getselectedPetriNetMap().getPetriNet().getTransitions()));
//		ProcessAnalyticsVizViews pa = new ProcessAnalyticsVizViews(null, net.getselectedPetriNetMap().getPetriNet(),
//				net.getLog(), TimeView.HOURS, ProcessView.CaseStart, ChartView.HISTOGRAM, GraphData.SyncMovesOnly);
		return new PNetVisualizerGUI(graph, net, null).getRootPane();
	}

	public static PNetVisualizerGUI newInteractiveViz(InteractivePetriNet net) {
		return new PNetVisualizerGUI(petrinetToGraph(net), net);
	}

	public static Graph petrinetToGraph(InteractivePetriNet ipn) {
		PetriNetMap pn = ipn.getselectedPetriNetMap();
		Petrinet d = pn.getPetriNet();
		Graph graph = new Graph(true);
		Map<PetrinetNode, Integer> nodeMap = new HashMap<>();
		initSchema(graph);

		int V = d.getNodes().size();
		PetrinetNode[] nodes = d.getNodes().toArray(new PetrinetNode[V]);
		int count = 0;

		for (PetrinetNode node : nodes) {
			Node n = graph.addNode();
			nodeMap.put(node, n.getRow());
			//			if(!ipn.getselectedPetriNetMap().getNodeMap().containsKey(node))
			//				ipn.getselectedPetriNetMap().getNodeMap().put(node, ipn.getselectedPetriNetMap().getNodeMap().size());
			//			
			//			int k = ipn.getselectedPetriNetMap().getNodeMap().get(node);

			if (node instanceof Place) {
				n.set("ID", ipn.getPlaceId((Place) node));
				n.set("InputOutputNodes", VizGraphParametersUtils.addHighlightPlacesBasedOnLDMatrix((Place) node, ipn));
			} else {
				n.set("ID", (ipn.getTranId((Transition) node)));
				n.set("InputOutputNodes",
						VizGraphParametersUtils.addHighlightTransBasedOnLDMatrix((Transition) node, ipn));
			}
			//				n.set("ID", k);

			if (node instanceof Place) {
				String str = "";
				n.set(PNConstants.NODE_TYPE_KEY, NodeType.PLACE.toString());

			} else {
				//add Follows Precedes Coccors relations
				String strtemp = "";
				System.out.println(node);
				n.set(PNConstants.NODE_TYPE_KEY, NodeType.TRANSITION.toString());
//				if ((ipn.getLogInfo() == null) || !ipn.getFollowsRelations().containsKey(node.toString()))
//					continue;
//
//				for (String key : ipn.getFollowsRelations().get(node.toString()).keySet()) {
//					strtemp += key + "," + ipn.getFollowsRelations().get(node.toString()).get(key) + ";";
//				}
//				n.set("Follows", strtemp);
//				strtemp = "";
//				for (String key : ipn.getCoOccorsRelations().get(node.toString()).keySet()) {
//					strtemp += key + "," + ipn.getCoOccorsRelations().get(node.toString()).get(key) + ";";
//				}
//				n.set("CoOccurs", strtemp);
			}
			n.set(PNConstants.NODE_LABEL_KEY, String.valueOf(node.toString()));
		}

		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> edge : d.getEdges()) {
			int source = nodeMap.get(edge.getSource());
			int target = nodeMap.get(edge.getTarget());

			System.out.println(source + " --> " + target);

			graph.addEdge(source, target);
		}

//		ipn.getInteractiveMatNet().setGraph(graph);//initialize graph for the first time!
		return graph;
	}

	private static void initSchema(Graph graph) {
		// Node attributes
		//		graph.getNodes().addColumn(PNConstants.NODE_TYPE_KEY, String.class, NodeType.PLACE.toString());
		////		graph.getNodes().addColumn(PNConstants.NODE_SIZE_KEY, int.class, 20);
		//		graph.getNodes().addColumn(PNConstants.NODE_LABEL_KEY, String.class, PNConstants.EMPTY_LABEL);
		//		//graph.getEdges().addColumn(PNConstants.EDGE_BENDS_KEY, List.class);
		//		graph.getNodes().addColumn(PNConstants.NODE_LAYER_KEY, int.class, 0);
		//		// graph.getNodes().addColumn(PNConstants.NODE_DEPTH, int.class, 0);
		//		graph.getNodes().addColumn(PNConstants.SIMPLIFIED_TOP_KEY, boolean.class, false);
		//		graph.getNodes().addColumn(PNConstants.SIMPLIFIED_BOTTOM_KEY, boolean.class, false);
		//		//         graph.getNodes().addColumn(PNConstants.SIMPLIFIED_TOP_DRAWN_KEY, boolean.class, false);
		//		//         graph.getNodes().addColumn(PNConstants.SIMPLIFIED_BOTTOM_DRAWN_KEY, boolean.class, false);
		//		//         graph.getEdges().addColumn(PNConstants.EDGE_SIMPLIFICABLE, boolean.class, true);
		//		//         graph.getEdges().addColumn(PNConstants.EDGE_SOURCE_PORT_OFFSET, float.class, 0f);
		//		//         graph.getEdges().addColumn(PNConstants.EDGE_TARGET_PORT_OFFSET, float.class, 0f); 
		//		// Global attribute because it's used later as a predicate for ALL items (including nodes)
		//		graph.addColumn(PNConstants.SIMPLIFIED_KEY, boolean.class, false);
		graph.addColumn("ID", int.class);
		graph.getNodes().addColumn("Preceding", String.class);
		graph.getNodes().addColumn("Follows", String.class);
		graph.getNodes().addColumn("CoOccurs", String.class);
		graph.getNodes().addColumn("ChoicePlaces1", ArrayList.class);
		graph.getNodes().addColumn("InputOutputNodes", ArrayList.class);
		graph.getNodes().addColumn("LoopPlaces", ArrayList.class);
		graph.getNodes().addColumn("PrePostNodes", ArrayList.class);
		// Edge attributes
		//		graph.getEdges().addColumn(PNConstants.EDGE_BENDS_KEY, List.class);
		//		graph.getEdges().addColumn(PNConstants.EDGE_COLOR_KEY, int.class, PNConstants.EDGE_DEFAULT_COLOR);
		//		graph.getEdges().addColumn(PrefuseLib.getStartField(PNConstants.EDGE_COLOR_KEY), int.class,
		//				PNConstants.EDGE_DEFAULT_COLOR);
		//		graph.getEdges().addColumn(PrefuseLib.getEndField(PNConstants.EDGE_COLOR_KEY), int.class,
		//				PNConstants.EDGE_DEFAULT_COLOR);

		//New Humberto attributes
		graph.getNodes().addColumn(PNConstants.NODE_TYPE_KEY, String.class, NodeType.PLACE.toString());
		//         graph.getNodes().addColumn(PNConstants.NODE_SIZE_KEY, double.class, 10);
		graph.getNodes().addColumn(PNConstants.NODE_LABEL_KEY, String.class, PNConstants.EMPTY_LABEL);
		//         graph.getNodes().addColumn(PNConstants.NODE_WIDTH_KEY, int.class, PNConstants.PLACES_DEFAULT_WIDTH);
		//         graph.getNodes().addColumn(PNConstants.NODE_HEIGHT_KEY, int.class, PNConstants.PLACES_DEFAULT_HEIGHT);
		graph.getNodes().addColumn(PNConstants.VISIBLE_IN_DEGREE, int.class, -1);
		graph.getNodes().addColumn(PNConstants.VISIBLE_OUT_DEGREE, int.class, -1);
		//         graph.getNodes().addColumn(PNConstants.NODE_TAU_TRANSITION, boolean.class, false);
		graph.addColumn(PNConstants.SIMPLIFIED_KEY, boolean.class, false);
		graph.getEdges().addColumn(PNConstants.EDGE_BENDS_KEY, List.class);
		graph.getNodes().addColumn(PNConstants.NODE_LAYER_KEY, int.class, 0);
		//         graph.getNodes().addColumn(PNConstants.NODE_DEPTH, int.class, 0);
		graph.getNodes().addColumn(PNConstants.SIMPLIFIED_TOP_KEY, boolean.class, false);
		graph.getNodes().addColumn(PNConstants.SIMPLIFIED_BOTTOM_KEY, boolean.class, false);
		graph.getEdges().addColumn(PNConstants.EDGE_SIMPLIFICABLE, boolean.class, true);
		graph.getEdges().addColumn(PNConstants.EDGE_SOURCE_PORT_OFFSET, float.class, 0f);
		graph.getEdges().addColumn(PNConstants.EDGE_TARGET_PORT_OFFSET, float.class, 0f);
		graph.getEdges().addColumn(PNConstants.EDGE_COLOR_KEY, int.class, PNConstants.EDGE_DEFAULT_COLOR);
		graph.getEdges().addColumn(PrefuseLib.getStartField(PNConstants.EDGE_COLOR_KEY), int.class,
				PNConstants.EDGE_DEFAULT_COLOR);
		graph.getEdges().addColumn(PrefuseLib.getEndField(PNConstants.EDGE_COLOR_KEY), int.class,
				PNConstants.EDGE_DEFAULT_COLOR);
		graph.getEdges().addColumn(PNConstants.EDGE_BIDIRECTIONAL, boolean.class, false);

	}
}
