package org.processmining.prabhakardixit.viz;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JComboBox;
import javax.swing.JComponent;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;

public class VisualizeInteractivePN {
	@Plugin(name = "@0 Visualize Interactive Petri Net Object", returnLabels = { "Visualized Interactive Petri Net Object" }, returnTypes = { JComponent.class }, parameterLabels = { "Interactive Perti Net Object" }, userAccessible = true)
	@Visualizer
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(UIPluginContext context, InteractivePetriNet ipn) {

		System.out.println("ea");
		PetriNetMap pn = ipn.getselectedPetriNetMap();
		ipn.setselectedPetriNetMap(pn);
		Map<String, Map<String, Double>> followsRelations = new HashMap<String, Map<String, Double>>();
		Map<String, Map<String, Double>> cooccursRelations = new HashMap<String, Map<String, Double>>();

		for (Transition tMain : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
			Map<String, Double> followsSet = new HashMap<String, Double>();
			followsSet.put("x1", 0.5);
			followsSet.put("x2", 0.4);
			followsSet.put("x3", 0.9);
			followsSet.put("x4", 1.0);
			followsSet.put("x5", 0.1);
			followsRelations.put(tMain.toString(), followsSet);
			Map<String, Double> cooccoursSet = new HashMap<String, Double>();

			cooccoursSet.put("x1", 0.5);
			cooccoursSet.put("x2", 0.4);
			cooccoursSet.put("x3", 0.9);
			cooccoursSet.put("x4", 1.0);
			cooccoursSet.put("x5", 0.1);
			cooccursRelations.put(tMain.toString(), followsSet);
		}
		//ipn.setFollowsRelations(followsRelations);
		//ipn.setCoOccorsRelations(cooccursRelations);

		return InteractivePetrinetVisualizer.asdfasdf(ipn);

	}

//	private JTabbedPane createTabbedPane(final InteractivePetriNet ipn, UIPluginContext context) {
//		VisualizeAcceptingPetriNetPlugin visualizerAcceptingPetriNet = new VisualizeAcceptingPetriNetPlugin();
//		JTabbedPane tabbedPane = new JTabbedPane();
//		/*
//		 * for (int index = 0; index <
//		 * ipn.getAcceptingPetriNetArray().getSize(); index++) { String label =
//		 * "Net " + (index + 1); tabbedPane.add(label,
//		 * visualizerAcceptingPetriNet.visualize(context,
//		 * ipn.getAcceptingPetriNetArray().getNet(index))); }
//		 */
//		for (int index = 0; index < ipn.getPetriNetMapList().size(); index++) {
//			String label = "Net " + (index + 1);
//			PetriNetMap pntemp = null;
//			if (index == 2)
//				pntemp = ipn.getPetriNetMapList().get(index);
//			else
//				pntemp = new PetriNetMap(ipn.getPetriNetMapList().get(index));
//			try {
//				//				if (ReducePetriNet.reducePetriNet(pntemp))
//				//					label += " - TRUE";
//				//				else
//				//					label += " - FALSE";
//			} catch (StackOverflowError e) {
//				System.err.println("Error in:  " + index);
//			}
//			AcceptingPetriNet apn = new AcceptingPetriNetImpl(ipn.getPetriNetMapList().get(index).getPetriNet());
//			tabbedPane.add(label, visualizerAcceptingPetriNet.visualize(context, apn));
//		}
//
//		return tabbedPane;
//	}
//
//	private void updateTabbedPane(UIPluginContext context, JTabbedPane tabbedPane, List<PetriNetMap> pnMapList,
//			final InteractivePetriNet ipn) {
//		tabbedPane.removeAll();
//		VisualizeAcceptingPetriNetPlugin visualizerAcceptingPetriNet = new VisualizeAcceptingPetriNetPlugin();
//		/*
//		 * for (int index = 0; index <
//		 * ipn.getAcceptingPetriNetArray().getSize(); index++) { String label =
//		 * "Net " + (index + 1); tabbedPane.add(label,
//		 * visualizerAcceptingPetriNet.visualize(context,
//		 * ipn.getAcceptingPetriNetArray().getNet(index))); }
//		 */
//		for (int index = 0; index < ipn.getPetriNetMapList().size(); index++) {
//			String label = "Net " + (index + 1);
//			PetriNetMap pntemp = new PetriNetMap(ipn.getPetriNetMapList().get(index));
//			System.out.println("P N " + index);
//			try {
//				//				if (ReducePetriNet.reducePetriNet(pntemp))
//				//					label += " - TRUE";
//				//				else
//				//					label += " - FALSE";
//			} catch (StackOverflowError e) {
//				System.err.println("Error in:  " + index);
//				//				for (LoopStartEndPlaces lpse : ipn.getPetriNetMapList().get(index).getLoopPlaces())
//				//					System.out.println(lpse.getStartLoopPlaces() + " " + lpse.getEndLoopPlaces());
//			}
//			AcceptingPetriNet apn = new AcceptingPetriNetImpl(ipn.getPetriNetMapList().get(index).getPetriNet());
//			tabbedPane.add(label, visualizerAcceptingPetriNet.visualize(context, apn));
//		}
//
//	}

	private JComboBox createActivityList(final InteractivePetriNet ipn) {
		JComboBox<String> activities = new JComboBox();
		//		for (String s : ipn.getActivityList()) {
		//			activities.addItem(s);
		//		}
		activities.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				ipn.setSelectedActivity(e.getItem().toString());
				e.paramString();
			}
		});
		return activities;
	}
}
