package org.processmining.reduction;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
import org.processmining.reduction.ReductionTracker.Rule;

public class DeleteUsingReduction {

	/**
	 * Try deleting the node using reduce either of the three rules
	 * 
	 * @param nodeid1
	 *            - Place - reduce using LDP, Tran - reduce using LDT or ABS
	 *            rule
	 * @param tran
	 * @param ipn
	 * @return true if node deleted, false otherwise
	 */
	public static Rule delete(int nodeid1, boolean tran, InteractivePetriNet ipn) {
		Transition transition = null;
		Place place = null;
		if (tran) {
			//TODO add abstraction and LDT reductions for delete
			transition = ipn.getTranBasedOnID(nodeid1);
		} else {
			place = ipn.getPlaceBasedOnID(nodeid1);
			Set<Integer> selectedInput = new HashSet<Integer>();
			Set<Integer> selectedOutput = new HashSet<Integer>();
			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e : ipn.getselectedPetriNetMap()
					.getPetriNet().getInEdges(place))
				selectedInput.add(ipn.getTranId((Transition) e.getSource()));
			for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e : ipn.getselectedPetriNetMap()
					.getPetriNet().getOutEdges(place))
				selectedOutput.add(ipn.getTranId((Transition) e.getTarget()));
			ipn.updateInteractiveMatNet(new ReductionTracker(Rule.LDPLACEREDUCE, selectedInput, selectedOutput,"", place
					.getLabel(), false, nodeid1, 0));
			return Rule.LDPLACEREDUCE;

		}
		return null;
	}

}
