package org.processmining.reduction;

import java.util.Set;

public class ReductionTracker {

	private Rule methodName;
	private Set<Integer> att1;
	private Set<Integer> att2;
	private boolean isSilent;
	private String tranName;
	private String placeName;
	private int newPlaceID;
	private int newTranID;

	public enum Rule {
		ABSTRACTION, LDPLACE, LDTRAN, ABSTRACTIONREDUCE, LDPLACEREDUCE, LDTRANREDUCE, RENAME
	}

	public ReductionTracker(Rule rule, Set<Integer> att1, Set<Integer> att2, String tranLabel,String placeLabel, boolean isSilentTran,
			int newPlaceID, int newTranID) {
		this.setAtt1(att1);
		this.setAtt2(att2);
		this.setMethodName(rule);
		this.setTranName(tranLabel);
		this.setPlaceName(placeLabel);
		this.setSilent(isSilentTran);
		this.setNewPlaceID(newPlaceID);
		this.setNewTranID(newTranID);
	}

	public ReductionTracker() {

	}

	public Rule getMethodName() {
		return methodName;
	}

	public void setMethodName(Rule methodName) {
		this.methodName = methodName;
	}

	public Set<Integer> getAtt1() {
		return att1;
	}

	public void setAtt1(Set<Integer> att1) {
		this.att1 = att1;
	}

	public Set<Integer> getAtt2() {
		return att2;
	}

	public void setAtt2(Set<Integer> att2) {
		this.att2 = att2;
	}

	public boolean isSilent() {
		return isSilent;
	}

	public void setSilent(boolean isSilent) {
		this.isSilent = isSilent;
	}

	public String getTranName() {
		return tranName;
	}

	public void setTranName(String name) {
		this.tranName = name;
	}
	public String getPlaceName() {
		return placeName;
	}

	public void setPlaceName(String name) {
		this.placeName = name;
	}
	public int getNewPlaceID() {
		return newPlaceID;
	}

	public void setNewPlaceID(int newPlaceID) {
		this.newPlaceID = newPlaceID;
	}

	public int getNewTranID() {
		return newTranID;
	}

	public void setNewTranID(int newTranID) {
		this.newTranID = newTranID;
	}

}
