package org.processmining.temp;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttributeBoolean;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.datapetrinets.expression.GuardExpression;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.DataElement;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PNWDTransition;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;

public class CreateLogWithAttributesNew {

	public static XLog getLogWithAttributes(XLog log, PetriNetWithData pnd) {
		//		GuardExpression guard = ((PNWDTransition) t).getGuardExpression();
		Set<String> variables = new HashSet<String>();
		//assume that var label is same as act name
		for (DataElement var : pnd.getVariables()) {
			variables.add(var.getVarName());
		}

		for (Transition t : pnd.getTransitions()) {
			GuardExpression guard = ((PNWDTransition) t).getGuardExpression();
			System.out.println(guard);
			//			System.out.println(" Transition  " + t + " guards : " + pnd.getGuards().get(t));
		}

		XFactory factory = XFactoryRegistry.instance().currentDefault();
		XLog subLog = factory.createLog((XAttributeMap) log.getAttributes().clone());

		subLog.getClassifiers().addAll(log.getClassifiers());
		subLog.getExtensions().addAll(log.getExtensions());
		subLog.getGlobalTraceAttributes().addAll(log.getGlobalTraceAttributes());
		subLog.getGlobalEventAttributes().addAll(log.getGlobalEventAttributes());

		for (String act : variables)
			subLog.getGlobalEventAttributes().add(factory.createAttributeBoolean(act, false, null));
		for (XTrace trace : log) {
			XTrace trace2 = factory.createTrace((XAttributeMap) trace.getAttributes().clone());

			Map<String, XAttributeBoolean> mapAtt = new HashMap<String, XAttributeBoolean>();
			for (String act : variables) {
				mapAtt.put(act, factory.createAttributeBoolean(act, false, null));
			}

			for (XEvent event : trace) {
				String act = XConceptExtension.instance().extractName(event).toString();
				XEvent event2 = (XEvent) event.clone();
				trace2.add(event2);
				for (String s : mapAtt.keySet()) {
					event2.getAttributes().put(s, mapAtt.get(s));
				}
				if (mapAtt.containsKey(act)) {
					mapAtt.get(act).setValue(true);
					event2.getAttributes().put(act, mapAtt.get(act));
				}
			}

			subLog.add(trace2);
		}

		return subLog;
	}
}
