package org.processmining.temp;

import java.util.HashSet;
import java.util.Map.Entry;
import java.util.Set;

import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Create log with attributes Trace level IUI", parameterLabels = { "Event Log", }, returnLabels = { "XLog" }, returnTypes = { XLog.class })
public class TraceLevelAttributesIUI {

	/**
	 * The method that does the heavy lifting for your plug-in.
	 * 
	 * Note that this method only uses the boolean which is stored in the
	 * configuration. Nevertheless, it could have used the integer and/or the
	 * String as well.
	 * 
	 * @param context
	 *            The context where to run in.
	 * @param input1
	 *            The first input.
	 * @param dclist
	 * @param log
	 * @param input2
	 *            The second input.
	 * @param configuration
	 *            The configuration to use.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	static Set<String> events = new HashSet<String>();
	public static boolean stop = false;

	public XLog yourPrivatePlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
			InstantiationException {

		XFactory factory = XFactoryRegistry.instance().currentDefault();
		XLog subLog = factory.createLog((XAttributeMap) log.getAttributes().clone());

		subLog.getClassifiers().addAll(log.getClassifiers());
		subLog.getExtensions().addAll(log.getExtensions());
		subLog.getGlobalTraceAttributes().addAll(log.getGlobalTraceAttributes());
		subLog.getGlobalEventAttributes().addAll(log.getGlobalEventAttributes());

		for(Entry<String, XAttribute> x : log.get(0).getAttributes().entrySet()){
			System.out.println(x.getKey());
		}
		Set<String> activities = new HashSet<String>();
		activities.add("Disease");
		activities.add("Prostate");
		activities.add("Bladder");

		
		
		XAttribute exam = factory.createAttributeLiteral("Exam", "",null);
		
		for (XTrace trace : log) {
			XTrace trace2 = factory.createTrace((XAttributeMap) trace.getAttributes().clone());
			
			XAttribute att = factory.createAttributeLiteral("Exam", trace.get(0).getAttributes().get("ExamName2").toString(), null);
			trace2.getAttributes().put("Exam", att);
			for (XEvent event : trace) {

				XEvent event2 = (XEvent) event.clone();
//				if (!XConceptExtension.instance().extractName(event).contains("Rect"))
					trace2.add(event2);
			}
			subLog.add(trace2);
		}

		return subLog;
	}

	/**
	 * The plug-in variant that runs in a UI context and uses a dialog to get
	 * the configuration.
	 * 
	 * @param context
	 *            The context to run in.
	 * @param input1
	 *            The first input.
	 * @param input2
	 *            The second input.
	 * @return The output.
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 */
	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
	@PluginVariant(variantLabel = "Reduce petrinet 22", requiredParameterLabels = { 0 })
	public XLog yourDefaultPlugin(UIPluginContext context, XLog logOrg) throws IllegalAccessException,
			InstantiationException {

		return yourPrivatePlugin(context, logOrg);

	}
}
